#-----------------------------------------------------------------------------
sub readSWVer
#-----------------------------------------------------------------------------
{
  &logit("Reading SWVer data from repository");

  ##$statement  = "select distinct distlist from dbamon.dist";
  ####print "statement=$statement\n";
  ##$sth2 = $dbh->prepare($statement) ||
  ##        &error_msg('Failed_on_DB_prepare_in_chgEnt');
  ##$sth2->execute || &error_msg('Failed_on_DB_execute_in_chgEnt');
  ##
  ##while (@Data = $sth2->fetchrow_array)
  ##{
  ##  $distlist = $Data[0];
  ##  undef $userlist[$distlist];
  ##  ##print "undefing userlist[$distlist]\n";
  ##}

  undef @swver_data;

  $statement  = "select
      swver_dbms,
      swver_family,
      swver_minver,
      swver_kbnum
    from 
      dbamon.swver
    order by
      1, 2, 3";

  ##print "statement=$statement\n";
  $sth2 = $dbh->prepare($statement) ||
          &error_msg('Failed_on_DB_prepare_in_chgEnt');
  $sth2->execute || &error_msg('Failed_on_DB_execute_in_chgEnt');

  $swver_count=0;
  $i = -1;

  while (@Data = $sth2->fetchrow_array)
  {
    $i++;

    $swver_i_dbms   = $Data[0];
    $swver_i_family = $Data[1];
    $swver_i_minver = $Data[2];
    $swver_i_kbnum  = $Data[3];

    $swver_i_dbms   =~ s/\s//g;
    $swver_i_family =~ s/\s//g;
    $swver_i_minver =~ s/\s//g;
    $swver_i_kbnum  =~ s/\s//g;
 
    ##print "swver_i_dbms=$swver_i_dbms swver_i_family=$swver_i_family swver_i_minver=$swver_i_minver\n";
    
    push(@swver_data, "$swver_i_dbms $swver_i_family $swver_i_minver $swver_i_kbnum");

    $swver_count++;
  }

  ##print "\n";
  ##foreach (@swver_data)
  ##{
  ##  print;
  ##  print "\n";
  ##}
  ##print "\n";

  &logit("Read $swver_count SWVer entries from repository");
}
1;
