# -----------------------------------------------------------------------------
sub sqlReqFile
# -----------------------------------------------------------------------------
{
  #---- Create a require file of parms for this instance
  my $zdate = &getdate;
  open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
  print TMPFL6 "#---- START Require file for Instance=\[$titleraw[$thishost]\] - Created $zdate\n"; 
  print TMPFL6 "\$rq_backup_age         = '$backup_age[$thishost]';\n";
  print TMPFL6 "\$rq_id1                = '$id1[$thishost]';\n";
  print TMPFL6 "\$rq_id2                = '$id2[$thishost]';\n";
  print TMPFL6 "\$rq_id3                = '$id3[$thishost]';\n";
  print TMPFL6 "\$rq_dbamonmode         = '$modeout';\n";

  #---- If the specified mssql_job_lr_check_name_excl_string - then include it. 
  if ($mssql_job_lr_check_name_excl_string[$thishost] ne "")
  {
    print TMPFL6 "\$rq_mssql_job_lr_check_name_excl_string = \"$mssql_job_lr_check_name_excl_string[$thishost]\";\n";
  }

  if ($mssql_addtl_drives[$thishost] ne "")
  {
    print TMPFL6 "\$rq_mssql_addtl_drives = \"$mssql_addtl_drives[$thishost]\";\n";
  }

  if ($dbc_parm[$thishost]{'prime_time_lrc_check'} eq "Y") 
  {
    print TMPFL6 "\$rq_mssql_prime_time_lrc_check = \"$dbc_parm[$thishost]{'prime_time_lrc_check'}\";\n";
  }

  if ($dbc_parm[$thishost]{'probe_parm'} ne "") 
  {
    print TMPFL6 "\$rq_probe_parm = \"$dbc_parm[$thishost]{'probe_parm'}\";\n";
  }

  #---- 5.57.F 2017/07/25 
  if ($mssql_log_exclude_strings[$thishost] ne "") 
  {
    print TMPFL6 "\@rq_log_exclude_strings = $mssql_log_exclude_strings[$thishost];\n";
  }

  #---- For CHECKLOG #1
  #my $local_mssql_log_min_sev = $mssql_log_min_sev[$thishost];
  #$local_mssql_log_min_sev = -99 if ! $local_mssql_log_min_sev;
  if ($mssql_log_min_sev[$thishost] > 0 ) { print TMPFL6 "\$rq_mssql_log_min_sev = $mssql_log_min_sev[$thishost];\n"; }
  else                                    { print TMPFL6 "\$rq_mssql_log_min_sev = -99;\n"; }

  #---- For CHECKLOG #2
  #my $local_dbc_udm_stringcheck = $dbc_udm_stringcheck[$thishost];
  #$local_dbc_udm_stringcheck = "?" if ! $local_dbc_udm_stringcheck;
  if ($dbc_udm_stringcheck[$thishost] ne "" ) { print TMPFL6 "\$rq_dbc_udm_stringcheck = \"$dbc_udm_stringcheck[$thishost]\";\n"; }
  else                                        { print TMPFL6 "\$rq_dbc_udm_stringcheck = \"?\";\n"; }

  #---- Return to caller (DownloadSW.pl)
  print TMPFL6 "#---- END   Require file for $titleraw[$thishost]\n"; 
  print TMPFL6 "1;\n"; 
  close(TMPFL6);

  #---- Copy to the download DIR
  use File::Copy;
  move("$tmpfl6", "$tmpdir/dbamon_mssql_req.pl") || &error("Cannot MOVE TMPFL6=$tmpfl6 to download dir - $!");
  $reqfile[$thishost] = "dbamon_mssql_req.pl"; 

  return;
}     

# -----------------------------------------------------------------------------
1;
