#-----------------------------------------------------------------------------
sub sqlUp
#-----------------------------------------------------------------------------
{
  ($thishost) = @_;

  my $leak_records = 0; 
  my $perlpath = ""; 
  my $zF3 = ""; 
  my $zF4 = ""; 

  my $this_line = ""; 

  my $tl_dbname   = ""; 
  my $tl_trunc    = ""; 
  my $tl_tlsize   = ""; 
  my $tl_pctused  = ""; 
  my $tl_drive    = ""; 
  my $tl_drivepct = ""; 
  my $tl_filename = ""; 
  my $tl_growth   = ""; 

  my $lr_jobs     = ""; 
  my $lr_job_cnt  = 0; 

  my $autoreorg_data = ""; 
  my $autoreorg_cnt  = 0; 

  my $mssql_lrc_cnt  = 0; 
  my $mssql_lrc_data = ""; 

  my $ssrs_logdata = ""; 
  my $rj_scoreboard = ""; 

  my $tlogmultifile_cnt = 0; 
  my $tlogmultifile_data = ""; 

  my %login_missingdefdb = ();
  my $login_missingdefdb_cnt = 0; 

  my @words = (); 

  my @ssrs_failed_reports = (); 

  my %dbspc_reserved_mb = (); 
  my %dbspc_tables_mb   = (); 
  my %dbspc_indexes_mb  = (); 
  my %dbspc_unused_mb   = (); 

  %ao_statusinfo   = (); 

  $totspc_reserved_mb = 0; 
  my $totspc_tables_mb = 0; 
  my $totspc_indexes_mb = 0; 
  my $totspc_unused_mb = 0; 

  my $fileperf_rank = 0; 
  $t_mi = -1; 

  $svcacct_pwexp_days = ""; 
  $svcacct_pwexp_ts = ""; 

  my $repl_max_lag_hrs = -99; 
  my $repl_www; 
  my $replcmds_www; 

  my $missing_goodparms = ""; 
  my $mssql_repl_nda = ""; 

  @sqltrans_data = (); 
  %trans_data    = (); 
  $trans_flag    = 0; 
  $tr_max_dur_hrs = -1; 
  $tr_max_tlog_gb = -1; 

  $activeses_flag    = 0; 
  @activeses_data    = (); 
  %activeses_entries = (); 

  $cpuprocess_flag    = 0; 
  @cpuprocess_data    = (); 
  %cpuprocess_entries = (); 

  $memprocess_flag    = 0; 
  @memprocess_data    = (); 
  %memprocess_entries = (); 

  $aoprocess_flag    = 0; 

  #---- Get Instance online data
  ##I don't know why i did this???  up[$thishost] = ""

  $titlehist[$thishost] = "?" if !$titlehist[$thishost];
  $title1[$thishost]    = "?" if !$title1[$thishost];

  $mssql_auto_reorg_type[$thishost] = ""; 

  #---- BB 28Jul06 - Changed defaults from 95/99 to 90/95
  #---- BB 02Jan11 - Changed defaults from 90/95 to 80/90
  $t_diskwarn[$thishost] = "80" if !$t_diskwarn[$thishost];
  $t_diskcrit[$thishost] = "90" if !$t_diskcrit[$thishost];

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    return;
  }

  #---- OLD, Obsolete
  if ($g_history_to_file eq "Y")
  {
    # Check to see if  we need to create history data
    chop($filedate = `date +%C%y.%m.%d`);
    chop($filetimedata= `date +%H:%M:%S`);
    $hist_flag = 0;
    if (system("grep '$titleraw[$thishost]' $hstdir/dbspaces/$filedate > /dev/null 2>&1") != 0)
    {
      &logit("Setting flag to create tblspace history data",$thishost);
      system("rm $tmpflt > /dev/null 2>&1");
      $hist_flag = 1;
    }
  }

  #---- Call PRE Userexit
  if (-x "/opt/dbamon/bin/userexit/inc_sqlup_pre")
  {
    if (! $inc_userexit) { $inc_userexit = 1; }
    require "inc_sqlup_pre"; 
    &inc_sqlup_pre;
  }

  #---- Start with a clean slate
  $up[$thishost] = "";
  $probeout_sqlup_file[$thishost] = ""; 

  $topwaits_data[$thishost] = ""; 

  $perf_timestamp[$thishost] = &getdate;    #---- Save this for later
  $perf_timestamp[$thishost] =~ s/\-/ /;    #---- Save this for later

  $must_connect = 1;

  #---- 5.44.B
  ##&remsh("$perlpath[$thishost] $probe[$thishost] up . $probe_parm[$thishost]",$tmpfl3,$thishost);
  &remsh("$perlpath[$thishost] $probe[$thishost] up . $probe_parm[$thishost]", $probeout_file[$thishost], $thishost);

  #---- 5.44.B
  ## #---- Copy PROBEOUT file to the log location, and save the filename into probeout_sqlup_file (for other routines)
  ## $probeout_sqlup_file[$thishost] = &probeLog; 

  if ($up[$thishost] eq "N")     # Remsh error
  {
    logit("(Connect Error)",$thishost);
    return;
  }

  my $db_good_owner = "SA";
  my $db_owner_fix;
  my $db_owner_rollback;
  my $db_owner_counter = 0;
  my $dbs_restoring = 0; 
  my $dbs_offline   = 0; 

  my $dbstatus = "";
  my $agentstatus = "";
  my $total_size = "";
  my $total_used = "";

  my $oldperl_kill = ""; 
  my $oldperl_details = ""; 
  my $oldperl_maxage = ""; 
  my $oldperl_pids = ""; 
  my $oldperl_cnt = 0; 

  my $this_lpim = ""; 

  my $cpu_arch = ""; 

  my $sql_config_msm = ""; 

  $badparms[$thishost] = "";
  $dbcount[$thishost] = "";
  $udbcount[$thishost] = 0;
  undef $tlogdata[$thishost];
  undef $drivedata[$thishost];
  undef $drivegrowthdata[$thishost];
  undef $fgdata[$thishost];
  my $diskdrivedata; 
  my $dbfileperfdata = ""; 
  my $ao_data = ""; 

  my $checkdbdata = ""; 
  my $checkdb_event_data = ""; 
  my $checkdb_event_cnt  = 0; 
  $perf_readings[$thishost]{"SQL_CheckDB_Max_Age_Days"} = -1; 

  $rmt_hostname[$thishost] = ""; 
  $os64bit[$thishost] = ""; 
  $mssql64bit[$thishost] = ""; 

  $target_shift[$thishost] = ""; 

  $windows_domain[$thishost] = ""; 
  $odbc_good_driver[$thishost] = ""; 

  undef $lrbackup_age_hrs[$thishost]; 
  undef $lrbackup_message[$thishost]; 
  undef $sqljob_data[$thishost]; 
  undef $sqlmissingindexes_data[$thishost]; 

  undef $cluster_name[$thishost]; 
  undef $cluster_status[$thishost]; 
  undef $cluster_onnode[$thishost]; 
  undef $cluster_thisnodestatus[$thishost]; 
  undef $save_config[$thishost];  
  undef %dbsize; 

  &logDetails($thishost,"<br><a name='sqlUpDBS'> <h3>MSSQL Databases</h3>");
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s DB<br>Name
    <th>$f_s Space<br>Used*<br>DB + TLog<br>(MB)
    <th>$f_s Space<br>Allocated<br>DB + TLog<br>(MB)
    <th>$f_s DB<br>Owner
    <th>$f_s Date<br>Last<br>Object Created
    <th>$f_s Space<br>Resrvd.<br>(MB)<br>=
    <th>$f_s Space<br>Table<br>(MB)<br>+
    <th>$f_s Space<br>Index<br>(MB)<br>+
    <th>$f_s Space<br>Unused<br>(MB)<br>+
    <th>$f_s DB Attributes<br>(Color from DBState)</tr>");

  open(PROBEOUT, "$probeout_file[$thishost]"  ) || &error_msg("Cannot open input $probeout_file[$thishost] - $!");
  while(<PROBEOUT>)
  {
    &parse;

    #---- Eliminate records that we don'ty care about
    next if $F1 =~ /^2/ && length($F1) == 19; 

    if ($F2 eq "SQLVer:")      
    { 
      ## #---- Test event
      ## &event("C",$thishost,"There are $zcount *SQL* Windows Services set to AUTOSTART which are Not Running: $zservices","Svcs_Not_Running_$zcount","DBA999");

      $z = $F3;

      # convert from x.xx.xxx format for x.xx.xxxx
      $z =~ tr/\(/./;
      $z =~ tr/\)//d;
      @words = split(/\./,$z);
      if (length($words[2]) == 3)
      {
	$z =~ s/$words[2]/0$words[2]/g;
      }
      #---- Since we now are in version 10.x, we need to pad earlier versions with zero 
      #----  so that it will sort correctly
      if (length($words[0]) == 1)
      {
	$z = "0" . $z;
      }

      $sw_version[$thishost] = $z;
      next;
    }

    if ($F2 eq "PERF:")    
    {
      $zkey = "SQL_" . $F3; 
      $perf_readings[$thishost]{$zkey} = $F4;
      next;
    }

    #---- dbamon_mssql.pl Stack: SaveConfig:
    if ($F2 eq "Stack:" && $F3 eq "SaveConfig:")    
    {
      $save_config[$thishost] .= $F0; 
      ##print "F0=$F0\n"; 
      next;
    }

    #---- dbamon_mssql.pl AUTOREORGTYPE: RYO^M
    if ($F2 eq "AUTOREORGTYPE:")    
    {
      $mssql_auto_reorg_type[$thishost] = $F3; 
      next;
    }

    #---- dbamon_mssql.pl SSRS_Log: <tr>
    if ($F2 eq "SSRS_Log:")    
    {
      $ssrs_logdata .= substr($F0,26); 
      ##print "DEBUG **Found** ssrs_logdata=$ssrs_logdata\n"; 
      next;
    }

    #---- dbamon_mssql.pl SvcsString: MSSQL MSSQL-Agent MSSQL-Browser OSWin
    if ($F2 eq "SvcsString:")    
    {
      $services_running[$thishost] = substr($F0,28); 
      ##print "DEBUG **Found** ssrs_logdata=$ssrs_logdata\n"; 
      next;
    }

    #----  dbamon_mssql.pl DB_Missing_Index_Threshold: 2000^M
    if ($F2 eq "DB_Missing_Index_Threshold:")    
    {
      $t_mi = $F3; 
      next;
    }

    #----  dbamon_mssql.pl ODBC_Good_Driver: ODBC Driver 13 for SQL Server
    if ($F2 eq "ODBC_Good_Driver:")    
    {
      $odbc_good_driver[$thishost] = substr($F0,34); 
      $odbc_good_driver[$thishost] =~ s/\n//; 
      ##print "DEBUG **Found** ODBC_Good_Driver=($odbc_good_driver[$thishost])\n"; 
      next;
    }

    #---- dbamon_mssql.pl VariableEvent: DBA999 W |MSSQL Log Checking Disabled by Probe_Parm: NoSQLLogCheck|NoSQLLogCheck|^M
    if ($F2 eq "VariableEvent:")    
    {
      my $z_eventid   = $F3; 
      my $z_sev       = $F4; 
      my $z_eventtext = (split(/\|/,($F0)))[1];
      my $z_short     = (split(/\|/,($F0)))[2];
      ##print "DEBUG **VariableEvent** z_eventid=($z_eventid) z_sev=($z_sev) z_eventtext=($z_eventtext) z_short=($z_short)\n"; 
      &event($z_sev, $thishost, $z_eventtext, $z_short, $z_eventid);
      next;
    }

    #---- dbamon_mssql.pl SvcsNotRunningAS: 2 SQLBrowser SQLWriter
    if ($F2 eq "SvcsNotRunningAS:")    
    {
      my $zcount    = $F3; 
      my $zservices = substr($F0,36); 
      $ev_cat = "Mgmt";
      &event("C",$thishost,"There are $zcount *SQL* Windows Services set to AUTOSTART which are Not Running: $zservices","Svcs_Not_Running_$zcount","DBA817");
      next;
    }

    #----  dbamon_mssql.pl DBsSingleUser: 1 bbtest3
    if ($F2 eq "DBsSingleUser:")    
    {
      my $zcount = $F3; 
      $zstart = index($F0, $F4);  #---- The start of the first DBNAME 
      my $znames = substr($F0,$zstart); 
      open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
      print TMPFL2 "DB(s) in SINGLE_USER Mode: 
$znames
      "; 
      close(TMPFL2);
      $ev_cat = "Mgmt";
      &event("W",$thishost,"There are $zcount MSSQL DBs(s) in SINGLE_USER mode","DBs_SINGLE_USER_$zcount","DBA818", $tmpfl2);
      next;
    }

    #---- Moved to sqlAlerts.pl
    #---- Moved to sqlAlerts.pl
    #----  dbamon_mssql.pl 18456_Events: 1
    #if ($F2 eq "18456_Events:")    
    #{   
    #  open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    #  print TMPFL2 "Number of 18456 Errors (invalid logins) found in SQL Error Log: $F3
    #
    #Check current SQL Error Log for details.
    #  "; 
    #  close(TMPFL2);
    #  &event("S",$thishost,"MSSQL Error=18456 Invalid Login(s) Found in Error Log","SuspectRows","DBA942", $tmpfl2);
    #  next;
    #}

    #---- dbamon_mssql.pl TargetShift: P
    if ($F2 eq "TargetShift:")    
    {
      $target_shift[$thishost] = $F3;
      next;
    }

    #---- dbamon_mssql.pl SSRS_Failed_Report: TimeEnd=2014-05-14 08:02:03.760 Status=rsProcessingAborted ReportPath=/Field Office Reports/Child Letters Inserted Username=CI\MCaballa 
    if ($F2 eq "SSRS_Failed_Report:")    
    {
      push (@ssrs_failed_reports, substr($F0,36));
      next;
    }

    #---- dbamon_mssql.pl SQLLoginMissingDefaultDB:   BBLogin6a BBTest6^M
    if ($F2 eq "SQLLoginMissingDefaultDB:")    
    {
      my $zml_login = $F3; 
      my $zml_db    = $F4; 
      $login_missingdefdb{$zml_login} = $zml_db; 
      $login_missingdefdb_cnt++; 
      next;
    }

    #---- dbamon_mssql.pl Prime_Time_LRC: CMD_Start_Time=2013-06-27 14:14:22.743 Command=DBCC TABLE CHECK Process_Age_Hours=0 SPID=69
    if ($F2 eq "Prime_Time_LRC:")    
    {
      $mssql_lrc_data .= substr($F0,32); 
      $mssql_lrc_cnt++; 
      next;
    }

    #---- dbamon_mssql.pl AUTOREORGAGE: Database=DBAMON  DaysSinceLastReorg=(Never)  Threshold=15 (Days)
    if ($F2 eq "AUTOREORGAGE:")    
    {
      $autoreorg_data .= substr($F0,30); 
      $autoreorg_cnt++; 
      next;
    }

    #---- dbamon_mssql.pl Jobs_Long_Running: 18.566666 12 {Test Long Runner AAA}
    if ($F2 eq "Jobs_Long_Running:")    
    {
      my $jb_hrs_running = $F3;
      my $jb_hrs_t       = $F4;
      my $jb_name = substr($F0,
                    index($F0, '{') +1,
                    (index($F0, '}') - index($F0, '{')) -1);

      $lr_job_cnt++;
      $lr_jobs .= "$lr_job_cnt. Job=($jb_name) HoursRunning=$jb_hrs_running HoursThreshold=$jb_hrs_t\n"; 

      $perf_readings[$thishost]{"SQL_Job_Max_Dur_Hrs"} = $jb_hrs_running; 

      next;
    }

    #---- $P SUSPECT_ROWCNT: $suspect_rowcnt
    if ($F2 eq "SUSPECT_ROWCNT:")    
    {
      $ev_cat = "Avail";
      &event("C",$thishost,"SUSPECT ROWS Found ($F3 rows) which indicated DB Corruption (SUSPECT_PAGES) - Investigate immediately","SuspectRows","DBA856");
      next;
    }

    #---- dbamon_mssql.pl AUTOREORGTIMEOUTCNT_L10D: Database=MyDB  TimeOutCnt=1^M
    if ($F2 eq "AUTOREORGTIMEOUTCNT_L10D:")    
    {
      $ev_cat = "Avail";
      &event("U",$thishost,"Found Auto-Reindex Timeouts Within the Last 10 Days - $F3 - $F4","ReindexTimeouts","DBA902");
      next;
    }

    #---- dbamon_mssql.pl RJSF_LastOKLoad_Age_Hrs: RJ_SF_CIProd 2  0.22
    if ($F2 eq "RJSF_LastOKLoad_Age_Hrs:")    
    {
      my $rj_dbname         = $F3;
      my $rj_loadokage_mins = $F4;
      my $rj_loadokage_hrs  = $F5;
      ##print "DEBUG - RJSF1 dbc=$dbc_parm[$thishost]{'mssql_rj_okload_age_hrs'}\n"; 

      my $zcolor = "white"; 
      if ($dbc_parm[$thishost]{'mssql_rj_okload_age_hrs'} ne "") 
      {
        ##print "DEBUG - RJSF2\n"; 
        my $t_warn = (split(/\//,($dbc_parm[$thishost]{'mssql_rj_okload_age_hrs'} )))[0];
        my $t_crit = (split(/\//,($dbc_parm[$thishost]{'mssql_rj_okload_age_hrs'} )))[1];
        my $z_sev = ""; 

        if    ($rj_loadokage_hrs >= $t_crit) { $z_sev = "C"; $z_val = $t_crit; $zcolor = "red"; } 
        elsif ($rj_loadokage_hrs >= $t_warn) { $z_sev = "W"; $z_val = $t_warn; $zcolor = "yellow"; } 
        else  { $zcolor = "lime"; }
  
        if ($z_sev ne "") 
        {
	  #---- If we are here, then do the event
	  open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
	  print TMPFL2 "RJ Target Database:          $rj_dbname\n";
	  print TMPFL2 "Hours Since Last OK Load:    $rj_loadokage_hrs\n";
	  print TMPFL2 "DBC MSSQL_RJ_OKLoad_Age_Hrs: $dbc_parm[$thishost]{'mssql_rj_okload_age_hrs'}\n"; 
	  print TMPFL2 "DBC Threshold (Warn):        $t_warn (Hours)\n"; 
	  print TMPFL2 "DBC Threshold (Crit):        $t_crit (Hours)\n"; 
	  close(TMPFL2);
	  $ev_cat = "Avail";
	  &event($z_sev,$thishost,"Too Long Since Last OK RJ Load for DB=$rj_dbname (Sev=$z_sev Threshold=$z_val Hour(s))","RJLoadAge","DBA863", $tmpfl2);
        }
      }

      $rj_scoreboard .= "<tr bgcolor=$zcolor>
        <td align=left >$f_s <b> $rj_dbname </b>
        <td align=right>$f_s $rj_loadokage_hrs 
        <td align=right>$f_s $dbc_parm[$thishost]{'mssql_rj_okload_age_hrs'} 
      ";

      next;
    }

    #---- Long running BACKUPs - In this order
    #-----  dbamon_mssql.pl LRBACKUP_AGE_DET: (No backups running)
    #-----  dbamon_mssql.pl LRBACKUP_AGE_HRS: -1
    #-----  undef $lrbackup_age_hrs[$thishost]; 
    #-----  undef $lrbackup_message[$thishost]; 
    if ($F2 eq "LRBACKUP_AGE_DET:")    
    {
      $lrbackup_message[$thishost] = substr($F0,34); 
      next;
    }

    #---- dbamon_mssql.pl SPConfig: index_create_memory_(KB)
    if ($F2 eq "SPConfig:")    
    {
      if ($F3 =~ /max_server_memory/i ||              #---- > 2000 
          $F3 =~ /maximum_size_of_server_memory/i)    #---- 2000
      {
        $sql_config_msm = $F4;
        if (length($sql_config_msm) == 10 && $sql_config_msm =~ /^214/)
        {
          $ev_cat = "Mgmt";
          &event("U",$thishost,"MSSQL Instance Max Memory ($F3) is set to INFINITE ($sql_config_msm)","MaxMemINFINITE","DBA860");
        }
      }
    }

    #---- dbamon_mssql.pl FILE_PCT_GROWTH: LOG 11
    #---- dbamon_mssql.pl FILE_PCT_GROWTH: ROWS 3
    if ($F2 eq "FILE_PCT_GROWTH:")    
    {
      my $zfiletype = $F3;
      my $zfilecnt  = $F4;

      $zfiletype = "DB" if $zfiletype eq "ROWS"; 

      if ($zfilecnt > 0) 
      {
	open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
	print TMPFL2 "To find which DB/LOG files have AUTOGROWTH set to a PERCENT, run:\n
SELECT 
  DB_NAME(database_id),
  name,
  type_desc,
  physical_name, 
  size, 
  max_size,
  growth
from 
  sys.master_files
where 
  is_percent_growth = 1
order by 
  1,2"; 
	close(TMPFL2);
        $ev_cat = "Mgmt";
        &event("U",$thishost,"Found $zfilecnt FileType=$zfiletype DB Files with PERCENT GROWTH","Files-$zfiletype-PctGrowth","DBA806", $tmpfl2);
      }
      next;
    }

    #---- dbamon_mssql.pl FILES_ON_C: C 27
    if ($F2 eq "FILES_ON_C:")    
    {
      my $zfilecnt  = $F4;
      if ($zfilecnt > 0 && $tot_disk_list[$thishost] ne "C") 
      {
	open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
	print TMPFL2 "To find which DB/LOG files reside on the C: drive, run:\n
SELECT 
  DB_NAME(database_id),
  name,
  type_desc,
  physical_name, 
  size, 
  max_size,
  growth
from 
  sys.master_files
where 
  physical_name like 'C:%'
order by 
  1,2"; 
	close(TMPFL2);
        $ev_cat = "Mgmt";
        &event("U",$thishost,"Found $zfilecnt DB/LOG Files on C: Drive","Files-C-Drive","DBA807", $tmpfl2);
      }
      next;
    }

    #---- dbamon_mssql.pl DB_File_Perf_Top_File: dbamon_log
    if ($F2 eq "DB_File_Perf_Top_File:")    
    {
      $mssql_busiest_lfile[$thishost] .= $F3; 
      ##$perf_readings[$thishost]{"SQL_DBFile_Busiest"} = $F3; 
    }

    #---- dbamon_mssql.pl DBMail_Server: ?
    if ($F2 eq "DBMail_Server:")    
    {
      $mssql_dbmail_server[$thishost] .= $F3; 
    }

    #---- dbamon_mssql.pl SQLPort: 54809
    if ($F2 eq "SQLPort:")    
    {
      $mssql_sqlport[$thishost] .= $F3; 
    }

    #---- dbamon_mssql.pl WindowsDomain: ?
    if ($F2 eq "WindowsDomain:")    
    {
      $windows_domain[$thishost] .= $F3; 
    }

    #---- dbamon_mssql.pl TLOGMultiFile: bbtest3 2
    if ($F2 eq "TLOGMultiFile:")    
    {
      $tlogmultifile_cnt++; 
      $tlogmultifile_data .= "DB=$F3 TLOGFileCount=$F4\n"; 
    }

    #---- dbamon_mssql.pl AO: Verb Noun 
    if ($F2 eq "AO:")    
    {
      $ao_verb = $F3;
      $ao_noun = $F4;
      $ao_data .= "
      <tr bgcolor=$table_rowcolor>
        <td>$f_s <b> $ao_verb </b>
        <td>$f_s $ao_noun 
      ";

      #---- Capture the AO Role
      if ($ao_verb eq "HADR_Role") 
      {
        $ao_status[$thishost] .= " $ao_noun"; 
      }

      #---- Capture the AO Role
      if ($ao_verb eq "HADR_Sync_Health") 
      {
        if ($ao_noun ne "HEALTHY") 
        {
          $ev_cat = "Avail";
          &event("C",$thishost,"AlwaysOn Sync Health is $ao_noun - Should be HEALTHY","AO_Not_Healthy","DBA710");
        }
      }

      #---- These will be needed for the SNAPSHOT at the end of this sub
      $ao_statusinfo{$ao_verb} = $ao_noun; 
      $aoprocess_flag      = 1; 

      next;
    }

    #---- dbamon_mssql.pl AO_Event: Vskjdalksjd
    if ($F2 eq "AO_Event:")    
    {
      open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
      print TMPFL2 "AlwaysOn Status Change Event:\n$F0";
      close(TMPFL2);
      $ev_cat = "Mgmt";
      my $z0 = substr($F0,61); 
      &event("N",$thishost,"MSSQL AlwaysOn Status Change: $z0","AO-Status-Chg","DBA947", $tmpfl2);

      next;
    }

    #---- dbamon_mssql.pl DB_File_Perf: DBAmon C:\MSSQL\MSSQL11.MSSQL2\MSSQL\DATA\dbamon.mdf 184780 429 429.7 226335 604 374.1 411115 1033 397.6
    if ($F2 eq "DB_File_Perf:")    
    {
      $fileperf_rank++; 
      $dbfileperfdata .= "
      <tr bgcolor=$table_rowcolor>
        <td align=right>$f_s $fileperf_rank.
        <td>$f_s <b> $F3 </b>
        <td>$f_s <b> $F4 </b>
        <td>$f_s <b> $F5 </b>
        <td align=right>$f_s $F6
        <td align=right>$f_s <b>$F7 </b>
        <td align=right>$f_s $F8
        <td align=right>$f_s $F9
        <td align=right>$f_s <b> $F10 </b>
        <td align=right>$f_s $F11
        <td align=right>$f_s $F12
        <td align=right>$f_s <b>$F13 </b>
        <td align=right>$f_s $F14
      ";
      next;
    }

    #---- dbamon_mssql.pl DBDFCount: tempdb 2
    if ($F2 eq "DBDFCount:")    
    {
      if (lc $F3 eq "tempdb") { $mssql_tempdb_dfcount[$thishost] = $F4; }
      next;
    }

    #---- dbamon_mssql.pl MSSQLServiceAccount:  .\mssql
    if ($F2 eq "MSSQLServiceAccount:")    
    {
      ##$mssql_service_account[$thishost] = $F3; 
      $mssql_service_account[$thishost] = $F_noun; 
      $mssql_service_account[$thishost] =~ s/\\\\/\\/; 
      $instance_details[$thishost] .= "|InstanceReading|SQLServiceAcct|$F3|\n" if $F3;
      next;
    }

    #---- dbamon_mssql.pl SIGNAL_Wait_Pct: 1.55 
    if ($F2 eq "SIGNAL_Wait_Pct:")    
    {
      $mssql_perf_signal_wait_pct[$thishost] = $F3; 
      next;
    }

    #---- dbamon_mssql.pl DISK_Tot_Size_GB: 142
    if ($F2 eq "DISK_Tot_Size_GB:")    
    {
      $tot_disk_gb[$thishost] = $F3; 
      &metricsInsert("sqlUp()",$thishost,"SPC_ALLDRIVES_GB",".",$F3);
      next;
    }

    #---- dbamon_mssql.pl DISK_Tot_List:    C
    if ($F2 eq "DISK_Tot_List:")    
    {
      $tot_disk_list[$thishost] = $F3; 
      next;
    }

    if ($F2 eq "LRBACKUP_AGE_HRS:")    
    {
      $lrbackup_age_hrs[$thishost] = $F3; 
      $lrbackup_age_hrs[$thishost] = 0 if $lrbackup_age_hrs[$thishost] eq "";
      if ($t_lrbackup_age_hrs[$thishost] > 0 && $lrbackup_age_hrs[$thishost] >= $t_lrbackup_age_hrs[$thishost])
      {
	open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
	print TMPFL2 "Details: $lrbackup_message[$thishost]\n";
	close(TMPFL2);

        $ev_cat = "Perf";
        &event("C",$thishost,"Longest Running BACKUP Command Has Been Running >= Threshold=$t_lrbackup_age_hrs[$thishost] (hours)","LongRunningDBBackup","DBA854", $tmpfl2);
      }
      #---- Record current and historical reading of this metric
      &metricsInsert ("sqlUp()",$thishost,"BACKUP_RUNNING_AGE_HRS",".",$lrbackup_age_hrs[$thishost]); 
      &metricsCurrent("sqlUp()",$thishost,"BACKUP_RUNNING_AGE_HRS","" ,$lrbackup_age_hrs[$thishost] ,"" ,$t_lrbackup_age_hrs[$thishost] ,"Max Backup Process Age (Hours) or NULL if no backup is running."); 
      next;
    }

    #---- Make TOP WAITS into SNAP report
    #---- dbamon_mssql.pl SYSPERF: SQL_Top_Waits_Rank1 PREEMPTIVE_XE_DISPATCHER 1 81.58
    #---- dbamon_mssql.pl SYSPERF: SQL_Top_Waits_Rank2 WRITELOG 2 14.16
    #---- dbamon_mssql.pl SYSPERF: SQL_Top_Waits_Rank3 PAGEIOLATCH_SH 3 2.04
    #---- dbamon_mssql.pl SYSPERF: SQL_Top_Waits_Rank4 PREEMPTIVE_OS_WRITEFILE 4 1.79
    #---- dbamon_mssql.pl SYSPERF: SQL_Top_Waits_Rank5 CXPACKET 5 .20
    if ($F2 eq "SYSPERF:" && $F3 =~ /^SQL_Top_Waits_Rank/)    
    {
      $topwaits_data[$thishost] .= $F0;
      ##print "Hit_TOPWAITS\n"; 
    }

    #---- SYSPERF data
    if ($F2 eq "SYSPERF:")    
    {
      if    ($F3 =~ /^SQL/)  { $zkey = $F3; }
      elsif ($F3 =~ /^SSRS/) { $zkey = $F3; }
      elsif ($F3 =~ /^NET/)  { $zkey = $F3; }
      else                   { $zkey = "SYS_" . $F3; }
      $perf_readings[$thishost]{$zkey} = $F4;

      #---- For pulling out a value needed in sqlUp
      ## print "$P SYSPERF: SQL_LPIM_Locked_KB $Data[0]\n";
      if ($F3 eq "SQL_LPIM_Locked_KB") 
      { 
        if ($F4 > 0) { $this_lpim = "On";  }
        else         { $this_lpim = "Off"; } 
      } 
  
      next;
    }

    #---- DBMAIL status 
    if ($F2 eq "DBMAIL_STATUS:")    
    {
      $dbmail_status[$thishost] = "$F3 $F4 $F5";
      if ($F3 !~ /^OK/) 
      { 
        $ev_cat = "Avail";
        &event("C",$thishost,"DBMail Status NG - Most Recent DBMail Log Entry Should be SENT - Status: $dbmail_status[$thishost]","DBMail_NG","DBA853");
      }
      next;
    }

    #---- dbamon_mssql.pl VLF_COUNT: dbamon 196
    if ($F2 eq "VLF_COUNT:")
    {
      $glob_vlf_data[$thishost] .= "$F3 $F4\n"; 
      next; 
    }

    #---- GOODPARMS (missing) Logic:
    #----   dbamon_mssql.pl GOODPARMS_Off: bbtest4 AUTOCREATESTATISTICS=0,AUTOUPDATESTATISTICS=0
    if ($F2 eq "GOODPARMS_Off:")    
    {
      $missing_goodparms .= "DB=$F3 - Problem(s): $F4\n"; 
      next;
    }

    #---- BADPARMS Logic: 
    #---- dbamon_mssql.pl BADPARMS: bbtest3[BLANK]bdprms ISAUTOSHRINK=1,ISAUTOSHRINK=1
    if ($F2 eq "BADPARMS:")    
    {
      $ev_cat = "Perf";
      &event("P",$thishost,"Poorly Performing DB Options Specified = DB=$F3 Parm(s)=($F4)","BadDBParms","DBA855");
      $badparms[$thishost] = $F4; 
      next;
    }

    #---- dbamon_mssql.pl CheckDBAge: DBName: DBAmon cdb_last_ts: 2017/07/09-12:00:17 cdb_hours_ago: 139.73^M
    #---- dbamon_mssql.pl CheckDBAge: DBName: BBTest3_Read[SPACE]Only cdb_last_ts: 1900/01/01-00:00:00 cdb_hours_ago: 1030785.42 cdb_flag: RO_DB^M

    if ($F2 eq "CheckDBAge:")    
    {
      ##print "DEBUG_CheckDBAge - F1=$F1 F2=$F2 F3=$F3 F4=($F4) F6=($F6)\n";  

      $cdb_db                = $F4; 
      $cdb_lastgood_ts       = $F6; 
      $cdb_lastgood_hoursago = $F8; 
      $cdb_flags             = $F10; 

      ##print "DEBUG_CheckDBAge - cdb_db=($cdb_db) cdb_lastgood_ts=($cdb_lastgood_ts)\n";  

      $cdb_lastgood_daysago  = sprintf("%.2f",($cdb_lastgood_hoursago / 24));

      if ($cdb_flags =~ /RO_DB/) 
      {
        $cdb_status = "This is a Read-Only DB - so CheckDB execution is not recorded"; 
        $cdb_color = "lightgray"; 
      }
      elsif ($cdb_lastgood_daysago >= $t_checkdb_age_days[$thishost])
      {
        $cdb_status = "Age of $cdb_lastgood_daysago (days) exceeds threshold of $t_checkdb_age_days[$thishost]"; 
        $cdb_color = $color_warn; 
        $checkdb_event_data .= "Database=$cdb_db LastGoodCheckDBTS=$cdb_lastgood_ts LastGoodCheckDBAgeDays=$cdb_lastgood_daysago ThresholdDays=$t_checkdb_age_days[$thishost]\n"; 
        $checkdb_event_cnt++; 
      }
      else
      {
        $cdb_status = "OK"; 
        $cdb_color = $color_good; 
      }

      $checkdbdata .= "
      <tr bgcolor=$cdb_color>
        <td>$f_s <b> $cdb_db </b>
        <td align=left >$f_s $cdb_lastgood_ts
        <td align=right>$f_s $cdb_lastgood_daysago
        <td align=right>$f_s $t_checkdb_age_days[$thishost]
        <td align=right>$f_s $cdb_flags
        <td align=right>$f_s $cdb_status
      ";
      if ($cdb_lastgood_daysago > $perf_readings[$thishost]{"SQL_CheckDB_Max_Age_Days"})
      {
        $perf_readings[$thishost]{"SQL_CheckDB_Max_Age_Days"} = $cdb_lastgood_daysago; 
      }
    }

    if ($F2 eq "DRIVESTATUS:")    
    {
      #---- dbamon_mssql.pl DRIVESTATUS: E 52094 43768 8326 84.02
      $drivedata[$thishost] .= $F0;
      $dr_drive = (split(/ /,$F0)) [2];
      $dr_size  = (split(/ /,$F0)) [3];
      $dr_used  = (split(/ /,$F0)) [4];
      $dr_free  = (split(/ /,$F0)) [5];
      $dr_pct   = (split(/ /,$F0)) [6];

      my $dr_pct_int = int($dr_pct); 

      ##print "DRIVESTATUS $titleraw[$thishost] $F0" if $dr_pct >= 90;
      #---- Data validation
      $ev_cat = "Mgmt";
      &event("U",$thishost,"Invalid Data: Drive=($dr_drive) shows a total size of ZERO - Something may be wrong with WMI?","DriveNG","DBA990",$tmpfl2) if $dr_size == 0;

      $color = "lightblue";
      $zt_disk_w = ""; 
      $zt_disk_c = ""; 

      #---- 5.57.B - Find the right threshold for this drive 
      # $t_diskfull_override[$i_hosts]{$zthisdrive} = $zthiswc;
      if ($t_diskfull_override[$thishost]{$dr_drive} ne "") 
      {
        @zwordst = split(/\//,$t_diskfull_override[$thishost]{$dr_drive}); 
        $zt_disk_w = $zwordst[0]; 
        $zt_disk_c = $zwordst[1]; 
      }
      else
      {
        $zt_disk_w = $t_diskwarn[$thishost]; 
        $zt_disk_c = $t_diskcrit[$thishost]; 
      }
      ##print "DEBUG_T_Disk_Override_Testing: $titleraw[$thishost] - dr_drive=$dr_drive - Using zt_disk_w=$zt_disk_w zt_disk_c=$zt_disk_c\n"; 

      if ($dr_drive ne "" && $dr_pct > 0) 
      {
        ##&metricsCurrent("sqlUp()",$thishost,"DRIVE_PCT_FULL",$dr_drive,$dr_pct,$t_diskwarn[$thishost],$t_diskcrit[$thishost],"Drives that contain SQL Data") unless $t_diskwarn[$thishost] eq "N"; 
        &metricsCurrent("sqlUp()",$thishost,"DRIVE_PCT_FULL",$dr_drive,$dr_pct,$zt_disk_w,$zt_disk_c,"Drives that contain SQL Data") unless $zt_disk_w eq "N"; 
      }

      open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
      print TMPFL2 "Drive:         $dr_drive\n";
      print TMPFL2 "Drive Size:    $dr_size (mb)\n";
      print TMPFL2 "Space Used:    $dr_used (mb)\n";
      print TMPFL2 "Space Free:    $dr_free (mb)\n";
      print TMPFL2 "Percent Full:  ${dr_pct} (percent)\n";
      close(TMPFL2);

      if ($zt_disk_w && $zt_disk_w ne "N")
      {
        if ($dr_pct >= $zt_disk_c)
        {
          $ev_cat = "Space";
          &event("C",$thishost,"Drive $dr_drive is ${dr_pct_int} percent full (Critical threshold: $zt_disk_c percent)","Drive_${dr_drive}_FullCrit","DBA805",$tmpfl2);
          $color = "pink";
          $zdrivestatus = "Critical"; 
        }
        elsif ($dr_pct >= $zt_disk_w)
        {
          $ev_cat = "Space";
          &event("W",$thishost,"Drive $dr_drive is ${dr_pct_int} percent full (Warning threshold: $zt_disk_w percent)","Drive_${dr_drive}_FullWarn","DBA805",$tmpfl2);
          $color = "yellow";
          $zdrivestatus = "Warning"; 
        }
        else
        {
          $color = "lime";
          $zdrivestatus = "OK"; 
        }
      }

      $diskdrivedata .= "
      <tr bgcolor=$color>
        <td>$f_s <b> $dr_drive </b>
        <td align=right>$f_s $dr_size
        <td align=right>$f_s $dr_used
        <td align=right>$f_s $dr_free
        <td align=right>$f_s <b> ${dr_pct}% </b>
        <td align=right>$f_s ${zt_disk_w}%
        <td align=right>$f_s ${zt_disk_c}%
        <td align=right>$f_s <b> $zdrivestatus </b>
      ";

      &metricsInsert("sqlUp()",$thishost,"DRIVE_PCT_FULL",$dr_drive,$dr_pct) if $dr_pct > 0;
      next;
    }

    #- dbamon_mssql.pl DISK_Drive_Space_Data: C SizeGB  917.66
    #- dbamon_mssql.pl DISK_Drive_Space_Data: C FreeGB  645.93
    #- dbamon_mssql.pl DISK_Drive_Space_Data: C UsedGB  271.73
    #- dbamon_mssql.pl DISK_Drive_Space_Data: C PctFull 29.61
    if ($F2 eq "Disk_Drive_Space_Data:")    
    {
      &metricsInsert("sqlUp()",$thishost,"SPC_Disk_$F4",$F3,$F5); 
      next; 
    }

    if ($F2 eq "TLOG:")    
    {
      $tlogdata[$thishost] .= $F0;
      ##print "TLOG F0=$F0\n";
      next; 
    }

    if ($F2 eq "FG_ITEM:")    
    {
      $fgdata[$thishost] .= $F0;
      ##print "FG_ITEM Found - F0=$F0\n";
      next;
    }

    if ($F2 eq "FG_DRIVE_GROWTH:")    
    {
      $drivegrowthdata[$thishost] .= $F0;
      ##print "FG_ITEM Found - F0=$F0\n";
      next;
    }

    if ($F2 eq "OS64BIT:" && $F3 == 1)    
    {
      $os64bit[$thishost] .= "(64bit)";
      next;
    }

    if ($F2 eq "MSSQL64BIT:" && $F3 == 1)    
    {
      $mssql64bit[$thishost] .= "(64bit)";
      next;
    }

    if ($F2 eq "MEM_PCT:")    
    {
      $mem_pct[$thishost] = $F3; 
      next;
    }
    if ($F2 eq "MEM_AVAIL:")  
    { 
      $mem_avail[$thishost] = $F3; 
      next;
    }
    if ($F2 eq "MEM_USED:")   
    { 
      $mem_used[$thishost] = $F3; 
      next;
    }
    if ($F2 eq "RAM:")        
    { 
      $ram[$thishost] = $F3; 
      $hw_memory[$thishost] = $F3; 

      #---- For "summarize"
      $total_shmem[$thishost] = $hw_memory[$thishost];

      next;
    }

    if ($F2 eq "CPU_BUSY_WITH_SQL:")   
    { 
      $cpu_busy_with_sql[$thishost] = $F3; 
      next;
    }

    if ($F2 eq "SQL_Details:")  #---- New 2011/02/06
    {
      $mssql_version[$thishost]     = $F3;
      $mssql_patchlevel[$thishost]  = $F4;
      $mssql_edition[$thishost]     = $F5;
      $mssql_licensetype[$thishost] = $F6;
      $mssql_numlicenses[$thishost] = $F7;

      #---- Edit EDITION
      if    ($mssql_edition[$thishost] =~ /standardedition/i)             { $mssql_edition[$thishost] = "SE"; }
      elsif ($mssql_edition[$thishost] =~ /enterpriseedition/i)           { $mssql_edition[$thishost] = "EE"; }
      elsif ($mssql_edition[$thishost] =~ /ExpressEditionwithAdvancedServices/i) { $mssql_edition[$thishost] = "ExpAdv"; }
      elsif ($mssql_edition[$thishost] =~ /ExpressEdition/i)              { $mssql_edition[$thishost] = "Express"; }
      elsif ($mssql_edition[$thishost] =~ /enterpriseevaluationedition/i) { $mssql_edition[$thishost] = "EEE"; }
      elsif ($mssql_edition[$thishost] =~ /desktopengine/i)               { $mssql_edition[$thishost] = "MSDE"; }
      else  { }

      #---- This shows the actual version of SQL better than SQLVer: - So if it is non-null, replace sw_version
      $sw_version[$thishost] = $mssql_version[$thishost] if $mssql_version[$thishost];

      #---- For proper sorting, insert a zero for older versions of SQL      
      my $zfirstnum = (split(/\./,$sw_version[$thishost])) [0]; 
      if (length($zfirstnum) == 1)
      {
        $sw_version[$thishost] = "0" . $sw_version[$thishost]; 
      }
      next;
    }

    if ($F2 eq "UPTIME:")  #---- New
    {
      $str_c = $F3;
      $str_n = $F4;
      $end_c = $F5;
      $end_n = $F6;
      &uptimeLog($thishost);

      $mssql_started = $str_c;
      $mssql_seconds_up = $end_n - $str_n;
      $mssql_upfor_hours = sprintf("%.2f",($mssql_seconds_up / (60*60)));
      $mssql_upfor_days[$thishost]  = sprintf("%.2f",($mssql_seconds_up / (60*60*24)));
      ##print "str_c=$str_c end_c=$end_c str_n=$str_n end_n=$end_n mssql_second_up=$mssql_seconds_up mssql_upfor_hours=$mssql_upfor_hours\n"; 
      next;
    }

    if ($F2 eq "OLDPERL:")    
    {
      $oldperl_details .= substr($F0,25); 
      $z = substr($F6,6); 
      $oldperl_maxage = $z if $z > $oldperl_maxage;
      $oldperl_cnt++;
      $zpid = substr($F3,4); 
      $oldperl_kill .= "<b>C:\\dbatools\\pskill $zpid</b>\n"; 
      $oldperl_pids .= "$zpid "; 
      next;
    }

    # print "DoubleTakeStatus: $doubletake_status\n";
    # print "DoubleTakeDir: $doubletake_dir\n";
    # print "DoubleTakeFile: $doubletake_file\n";
    # print "DoubleTakeFileAgeMins: $doubletake_fileage_mins\n";
    if ($F2 eq "DoubleTakeStatus:")      {  $doubletake_status[$thishost] = $F3; next; }
    if ($F2 eq "DoubleTakeDir:")         {  $doubletake_dir[$thishost] = $F3; next; }
    if ($F2 eq "DoubleTakeFile:")        {  $doubletake_file[$thishost] = $F3; next; }
    if ($F2 eq "DoubleTakeFileAgeMins:") {  $doubletake_fileage_mins[$thishost] = $F3; next; }

    # dbamon_mssql.pl CLUSTERNAME: LSCASQLTEST
    # dbamon_mssql.pl CLUSTERSTATUS: Online
    # dbamon_mssql.pl CLUSTERONNODE: WCOSDBT1
    # dbamon_mssql.pl CLUSTERTHISNODESTATUS: Passive
    if ($F2 eq "CLUSTERNAME:")           {  $cluster_name[$thishost] = $F3; next; }
    if ($F2 eq "CLUSTERSTATUS:")         {  $cluster_status[$thishost] = $F3; next; }
    if ($F2 eq "CLUSTERONNODE:")         {  $cluster_onnode[$thishost] = $F3; next; }
    if ($F2 eq "CLUSTERTHISNODESTATUS:") {  $cluster_thisnodestatus[$thishost] = $F3; next; }

    #---- Save DB attributes
    if ($F2 eq "DB_ATTRS:")    
    {  
      $zdb = $F3;
      $db_attrs[$thishost]{$zdb} = $F4; 
      if ($F4 =~ /\,Recovery/ && $F4 !~ /SIMPLE/) { $dbs_not_simple[$thishost]++; } 
      ##print "db_attrs=$db_attrs[$thishost]{$F3} F3=$F3\n";
      if ($F4 =~ /state=restoring/i) { $dbs_restoring++; } 
      if ($F4 =~ /state=offline/i)   { $dbs_offline++; } 
      next;
    }

    if ($F2 eq "NET_IP:")      {  $net_ip[$thishost] = $F3 ; next; }
    if ($F2 eq "NET_VLAN:")    {  $net_vlan[$thishost] = $F3 ; next; }
    if ($F2 eq "NET_COMPANY:") {  $net_company[$thishost] = $F3 ; next; }

    #----  dbamon_mssql.pl REPL_DIST: Y
    if ($F2 eq "REPL_DIST:") {  $mssql_repl_dist[$thishost] = $F3 ; next; }

    #---- "REPL_Agent_Non_Default_Profile: $re_agent_name $re_agent_profile"
    if ($F2 eq "REPL_Agent_Non_Default_Profile:") 
    { 
      $mssql_repl_nda .= "DistAgent: $F3  AgentProfile: $F4\n"; 
    }

    #---- dbamon_mssql.pl REPL_Stat:  CORPORATE3-compass3-Compass3_DW_Transacti-CORPORATE4-158  158  2012-10-21 10:05:16.880  3
    if ($F2 eq "REPL_Stat:") 
    { 
      my $mssql_repl_subname  = $F3 ; 
      my $mssql_repl_subnum   = $F4 ; 
      my $mssql_repl_tslast   = "$F5 $F6" ; 
      my $mssql_repl_lag_hrs  = $F7 ; 

      my $mssql_repl_color = "white"; 

      #---- 2012/12/27 BB: 5.40C - See if this subnum is INHIBITED for this day of the month
      #----   Save the value repl_inhib_count for later - if it's > 0 then we won't count this subscription
      my      $inhibit_file_subnum_dom = "/opt/dbamon/adm/inhibit/MSSQL_Repl_DOM.txt";
      if (-e "$inhibit_file_subnum_dom")
      {
	chop(my $domnum = `date +%e`);
	my $mssql_subnum_dom_string = "${domnum}/${mssql_repl_subnum}"; 
	   $mssql_subnum_dom_string =~ s/\s//g;
	my $repl_inhib_dom_cnt = &mygrep($mssql_subnum_dom_string, "$inhibit_file_subnum_dom", "$tmpfl1");
      }
      else
      {
	my $repl_inhib_dom_cnt = -1; 
      }

      #---- 2012/11/02 BB: 5.39G - If MSSQL_Repl_Lag_Excl_String: DBC parm was specified, then do not count subscriptions with
      #----   that string in the name against the MAX LAG. 
      #---- 2014/02/28 BB: Added logic to allow you to specify MULTIPLE comma-delimited list of strings
      if ($mssql_repl_lag_hrs > $repl_max_lag_hrs)
      {
        #---- This IS eligible to be counted against the MAX LAG
        my $lag_flag = 1;   #---- haha good name. By default we WILL count this one

        #---- Old
        #if ($mssql_repl_lag_excl_string[$thishost] ne ""
        #    && index($mssql_repl_subname, $mssql_repl_lag_excl_string[$thishost]) > -1)
        #---- New 2014/02/28 
        if ($mssql_repl_lag_excl_string[$thishost] ne "")
        {
          #---- See if this mssql_repl_subname IS excluded
          foreach $this_excl_string ( split(/\,/, $mssql_repl_lag_excl_string[$thishost]))
          {
            if (index($mssql_repl_subname, $this_excl_string) > -1) 
            { 
              $lag_flag = 0; 
            } 
          }
        }

        if ($repl_inhib_dom_cnt > 0)    #---- Was this one EXCLUDED by the Day of Month Inhibit check directly above? 
        {
          #---- This one IS excluded - Inhibited this DOM
          $lag_flag = 0; 
        }

        if ($lag_flag == 1)   #---- This was NOT excluded, so it will count against repl_max_lag_hrs!
        {
          $repl_max_lag_hrs = $mssql_repl_lag_hrs;
          $repl_sub_worst   = $mssql_repl_subname;
        }
      }
      
      $mssql_repl_color = "pink" if $mssql_repl_lag_hrs >= 1; 
      #---- This will be a GLOBAL

      $repl_www .= "<tr bgcolor=$table_rowcolor>
        <td>$f_s $mssql_repl_subname </td>
        <td>$f_s $mssql_repl_subnum  </td>
        <td>$f_s $mssql_repl_tslast  </td>
        <td align=right bgcolor=$mssql_repl_color> <b>$f_s $mssql_repl_lag_hrs </b> </td>
      </tr>
      "; 
      next; 
    }

    #---- dbamon_mssql.pl REPL_Dist_Agent_Undist_Cmds: DESKTOP-5TEU6AU-BBTest4-BBTest4_Pub1-DESKTOP-5TEU6AU-3 78^M
    if ($F2 eq "REPL_Dist_Agent_Undist_Cmds:")         
    {
      $z_agent  = $F3; 
      $z_cmdcnt = $F4; 

      if    ($z_cmdcnt >= $t_repl_undist_cmds_c[$thishost]) 
      { 
        $z_replcolor = $color_bad; 
      } 
      elsif ($z_cmdcnt >= $t_repl_undist_cmds_w[$thishost]) 
      { 
        $z_replcolor = $color_warn; 
      } 
      else                                                  
      { 
        $z_replcolor = $color_good; 
      } 

      $replcmds_www .= "<tr bgcolor=$table_rowcolor>
        <td>$f_trow $z_agent </td>
        <td align=right bgcolor=$z_replcolor> <b>$f_trow $z_cmdcnt </b> </td>
      </tr>
      "; 
    }

    #---- DaysSinceLastReboot: 2.17
    #---- OLD: 
    ##if ($Fz eq "DaysSinceLastReboot:")  { $os_days_since_last_reboot[$thishost] = $F2; next; }
    #---- NEW:
    #----   dbamon_mssql.pl OS_LastReboot:           2012/07/06-15:01:37
    #----   dbamon_mssql.pl OS_LastRebootDaysSince:  0.03
    if ($F2 eq "OS_LastRebootDaysSince:")  { $os_days_since_last_reboot[$thishost] = $F3; next; }
    if ($F2 eq "OS_LastReboot:")           { $os_last_reboot[$thishost] = $F3; next; }

    if ($F2 eq "PERLPATH:")           { $perlpath = $F3; next; }

    if ($F2 eq "CPUClockSpeedMHz:")     {  $hw_clockspeedmhz[$thishost] = $F3; next; }
    if ($F2 eq "CPUArch:")              {  $cpu_arch = $F3; next; }
    if ($F2 eq "OSVer:")       {  $os_version[$thishost] = "$F3 $F4"; next; }
    if ($F2 eq "DBStatus:")    {  $dbstatus = $F3; next; }
    if ($F2 eq "AgentStatus:") {  $agentstatus = $F3; next; }
    if ($F2 eq "NumCPUs:")     {  $hw_processors[$thishost] = $F3; next; }

    if ($F2 eq "CPUModel:")    {  $hw_model[$thishost] = $F3; next; }

    if ($F2 eq "SpaceAlloc:")  {  $total_size = $F3; next; }
    if ($F2 eq "SpaceUsed:")   {  $total_used = $F3; next; }
    if ($F2 eq "MSSQLServiceStatus:")   { $servicestatus = $F3; next; }
    if ($F2 eq "HOSTNAME:")    {  $rmt_hostname[$thishost] = $F3; next; }
    if ($F2 eq "RSHService:")  {  $rsh_service[$thishost] = $F3; next; }
    if ($F2 eq "ServerType:")  {  $server_type[$thishost] = $F3; next; }


    #---- 2012/09/12 BB: New DB Space breakdown metrics - 5.39.C
    #---- dbamon_mssql.pl DB_Space_Reserved_MB: dbamon 81.69
    if ($F2 eq "DB_Space_Reserved_MB:")  
    {  
      &metricsInsert("sqlUp()",$thishost,"SPC_DB_RESERVED_MB",$F3,$F4);
      $dbspc_reserved_mb{$F3} = $F4; 
      $totspc_reserved_mb += $F4; 
      next;
    }
    #---- dbamon_mssql.pl DB_Space_Tables_MB:   dbamon 33.77
    if ($F2 eq "DB_Space_Tables_MB:")  
    {  
      &metricsInsert("sqlUp()",$thishost,"SPC_DB_TABLES_MB",$F3,$F4);
      $dbspc_tables_mb{$F3} = $F4; 
      $totspc_tables_mb += $F4; 
      next;
    }
    #---- dbamon_mssql.pl DB_Space_Indexes_MB:  dbamon 41.20
    if ($F2 eq "DB_Space_Indexes_MB:")  
    {  
      &metricsInsert("sqlUp()",$thishost,"SPC_DB_INDEXES_MB",$F3,$F4);
      $dbspc_indexes_mb{$F3} = $F4; 
      $totspc_indexes_mb += $F4; 
      next;
    }
    #---- dbamon_mssql.pl DB_Space_Unused_MB:   dbamon 6.72
    if ($F2 eq "DB_Space_Unused_MB:")  
    {  
      &metricsInsert("sqlUp()",$thishost,"SPC_DB_UNUSED_MB",$F3,$F4);
      $dbspc_unused_mb{$F3} = $F4; 
      $totspc_unused_mb += $F4; 
      next;
    }

    if ($F2 eq "DB:")
    {
      $this_db = $F3;
      $this_db_owner = uc $F8; 

      #---- Debug field mismatch problem for tempdb - 20110921
      #print "$titleraw[$thishost] - F0=$F0\n" if $F0 =~ /tempdb/i; 

      if ($F3 eq "CONNECTERROR")
      {
        $ev_cat = "Avail";
        &event("C",$thishost,"MSSQL Active But DB $F3 Is OFFLINE","MSSQLDBOff","DBA804C",$probeout_file[$thishost]);
      }
      else
      {
        #---- Create LOG entry for thsi DB
	$zF4 = sprintf "%9.2f",$F4;
	$zF5 = sprintf "%9.2f",$F5;
	&logDetails($thishost,"<tr bgcolor=white>
          <td>$f_s <b> $F3 </b> 
          <td align=right>$f_s $zF5 
          <td align=right>$f_s $zF4
          <td >$f_s $this_db_owner
          <td nowrap>$f_s $F6:$F7
          <td align=right>$f_s $dbspc_reserved_mb{$F3} 
          <td align=right>$f_s $dbspc_tables_mb{$F3} 
          <td align=right>$f_s $dbspc_indexes_mb{$F3} 
          <td align=right>$f_s $dbspc_unused_mb{$F3} 
        ");

        #---- Log DB atrributes (if any)
        ##print "db_attrs=$db_attrs[$thishost]{$F2} F2=$F2\n";
        if ( $db_attrs[$thishost]{$F3} )
        {
          my $zcolor = "white"; 
          if ($db_attrs[$thishost]{$this_db} =~ /state=online/i)    { $zcolor = "lime"; } 
          if ($db_attrs[$thishost]{$this_db} =~ /state=restoring/i) { $zcolor = "yellow"; } 
          if ($db_attrs[$thishost]{$this_db} =~ /state=offline/i)   { $zcolor = "pink"; } 
          if ($db_attrs[$thishost]{$this_db} =~ /status=online/i)    { $zcolor = "lime"; } 
          if ($db_attrs[$thishost]{$this_db} =~ /status=restoring/i) { $zcolor = "yellow"; } 
          if ($db_attrs[$thishost]{$this_db} =~ /status=offline/i)   { $zcolor = "pink"; } 
          if ($db_attrs[$thishost]{$this_db} =~ /,snapshot/i)       { $zcolor = "lightblue"; } 
          if ($db_attrs[$thishost]{$this_db} =~ /,readonly/i)       { $zcolor = "lightblue"; } 
	  &logDetails($thishost,"<td bgcolor=$zcolor>$f_s $db_attrs[$thishost]{$this_db}");
        }

        #---- Current metric entry
        &metricsCurrent("sqlUp()",$thishost,"DB_RUNNING",$F3,-1,"","","DB Attributes: $db_attrs[$thishost]{$this_db}"); 

        #---- DB Owner processing
	$this_db_owner =~ s/\\\\/\\/;
	if ($this_db_owner eq $db_good_owner)
	{
	  ##$c_owner = "lime";
	}
        #---- 2012/05/10 BB: Mystery owner - take no action
	elsif ($this_db_owner eq "?")
	{
	}
        #---- 2011/12/20 BB: New
	elsif (index(uc $mssql_db_ok_owners[$thishost],uc $this_db_owner) > -1)
	{
	  ##$c_owner = "lime";
	}
	else
	{
	  ##$c_owner = "pink";
	  $db_owner_counter++;
          my $this_db_fix = $this_db;
          $this_db_fix =~ s'\[BLANK\]' 'g;
          $this_db_fix =~ s'\[HYPHEN\]'-'g;
	  $db_owner_fix      .= "-- $db_owner_counter. Change - DB [$this_db_fix] ($this_db) Owner from $this_db_owner to $db_good_owner
    USE [$this_db_fix]
    GO
    EXEC sp_changedbowner '$db_good_owner'
    GO\n";
	  $db_owner_rollback .= "-- $db_owner_counter. Rollback - DB [$this_db_fix] ($this_db) Owner from $db_good_owner to $this_db_owner
    -- USE [$this_db_fix]
    -- GO
    -- EXEC sp_changedbowner '$this_db_owner'
    -- GO\n";
	}

	if ($g_history_to_file eq "Y")
	{
	  if ($hist_flag)
	  {
	    system("echo '$filedate $filetime $title[$thishost] $F3 . $F4 $F5 $dbms[$thishost]' >> $tmpflt");
	  }
        }

	#--- OBSOLETE -  Create repository history data
	## &histCreate("sqlUp()",$thishost,"SPC",$F2,$zF3,$zF4);

        #---- Metrics
	&metricsInsert("sqlUp()",$thishost,"SPC_DB_ALLOC",$F3,$zF4);
	&metricsInsert("sqlUp()",$thishost,"SPC_DB_USED" ,$F3,$zF5);

        #---- Save this for later
        $dbsize{$F3} = $F4;

        #---- Increment db counter
        $dbtot_mssql++;
        $gbtot_mssql += ($F4 / 1000);

        $dbcount[$thishost]++;

        #---- Is this a non-system DB?
        if (lc $this_db ne "master" && 
            lc $this_db ne "model"  && 
            lc $this_db ne "msdb"   && 
            lc $this_db ne "cicentral"   && 
            lc $this_db ne "tempdb")
        {
          $udbcount[$thishost]++;
        }

        $dblist[$thishost] .= $F3 . "\n";
      }
      next;   #---- DB:
    }

    #---- DDP fields - START
    if ($F0 =~ /^DDP:/ && $F0 =~ /JOBS:/)
    {
      $sqljob_data[$thishost] .= $F0;
      next; 
    }

    if ($F0 =~ /^DDP:/ && $F0 =~ /TRANS_ACTIVE:/)
    {
      $sqltrans_data[$thishost] .= $F0;
      $trans_flag = 1; 
      next; 
    }

    if ($F0 =~ /^DDP:/ && $F0 =~ /SNAP_SES_ACTIVE:/)
    {
      $activeses_data[$thishost] .= $F0;
      $activeses_flag = 1; 
      next; 
    }

    if ($F0 =~ /^DDP:/ && $F0 =~ /SNAP_CPU_PROCESS:/)
    {
      $cpuprocess_data[$thishost] .= $F0;
      $cpuprocess_flag = 1; 
      next; 
    }

    if ($F0 =~ /^DDP:/ && $F0 =~ /MISSINGINDEXES:/)
    {
      $sqlmissingindexes_data[$thishost] .= $F0;
      $sqlmissingindexes_flag = 1; 
      next; 
    }

    if ($F0 =~ /^DDP:/ && $F0 =~ /SNAP_MEM_TOP:/)
    {
      $memprocess_data[$thishost] .= $F0;
      $memprocess_flag = 1; 
      next; 
    }
    #---- DDP fields - END

    #---- We really should never get here
    $leak_records++; 
    ##print "DEBUG_SQLUP: $F0";
  }
  close(PROBEOUT);

  ##print "DEBUG_SQLUP: leak_records=$leak_records\n";

  $ztotal_size = sprintf "%9.2f",$total_size;
  $ztotal_used = sprintf "%9.2f",$total_used;
  ##print "$ztotal_size $ztotal_used \n";

  $totspc_reserved_mb = sprintf("%.2f", $totspc_reserved_mb); 
  $totspc_tables_mb   = sprintf("%.2f", $totspc_tables_mb); 
  $totspc_indexes_mb  = sprintf("%.2f", $totspc_indexes_mb); 
  $totspc_unused_mb   = sprintf("%.2f", $totspc_unused_mb); 

  #---- New 2014/01/09 5.47.D
  $perf_readings[$thishost]{"SQL_Tot_Space_Reserved_MB"} = $totspc_reserved_mb; 
  $perf_readings[$thishost]{"SQL_Tot_Space_Tables_MB"}   = $totspc_tables_mb; 
  $perf_readings[$thishost]{"SQL_Tot_Space_Indexes_MB"}  = $totspc_indexes_mb; 
  $perf_readings[$thishost]{"SQL_Tot_Space_Objects_MB"}  = $totspc_tables_mb + $totspc_indexes_mb; 
  $perf_readings[$thishost]{"SQL_Tot_Space_Unused_MB"}   = $totspc_unused_mb; 

  &metricsInsert("sqlUp()",$thishost,"SPC_TOT_RESERVED_MB", ".", $totspc_reserved_mb);
  &metricsInsert("sqlUp()",$thishost,"SPC_TOT_TABLES_MB",   ".", $totspc_tables_mb);
  &metricsInsert("sqlUp()",$thishost,"SPC_TOT_INDEXES_MB",  ".", $totspc_indexes_mb);
  &metricsInsert("sqlUp()",$thishost,"SPC_TOT_OBJECTS_MB",  ".", $totspc_tables_mb + $totspc_indexes_mb);
  &metricsInsert("sqlUp()",$thishost,"SPC_TOT_UNUSED_MB",   ".", $totspc_unused_mb);

  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s Total ($dbcount[$thishost] DBs):
    <th align=right>$f_s $ztotal_used
    <th align=right>$f_s $ztotal_size
    <th align=right>$f_s &nbsp; 
    <th align=right>$f_s &nbsp; 
    <th align=right>$f_s $totspc_reserved_mb
    <th align=right>$f_s $totspc_tables_mb
    <th align=right>$f_s $totspc_indexes_mb
    <th align=right>$f_s $totspc_unused_mb
    <th>$f_s &nbsp; 
  </tr>");
  &logDetails($thishost,"</table>");
  &logDetails($thishost,"<br> &nbsp; *<b>Space Used</b> values are gathered from SP_SPACEUSED, which can be inaccurate. Run <b>SP_SPACEUSED \@UPDATEUSAGE='TRUE'</b> to correct.<p><hr>");

  if ($sw_version[$thishost] lt $ver_mssql_low  || $ver_mssql_low eq "" ) { $ver_mssql_low  = $sw_version[$thishost] }
  if ($sw_version[$thishost] gt $ver_mssql_high || $ver_mssql_high eq "") { $ver_mssql_high = $sw_version[$thishost] }

  $system_size[$thishost] = $total_size / 1000;  
  $system_used[$thishost] = $total_used / 1000;  
  ##print "su=$system_used[$thishost] $title[$thishost] \n";
  $grand_total_size += ($total_size / 1000);  

  # Check status
  if ($servicestatus eq "[Running]")
  {
    $dbmsg = "MSSQL Service IS Running";
  }
  else
  {
    $dbmsg = "MSSQL Service Is NOT Running";
  }
  if ($dbstats eq "")
  {
    $dbmsg .= ",Cannot Run SQL";
  }

  if ($dbstatus ne "UP")
  {
    $up[$thishost] = "N";
    &history_dummy($thishost);
    $hist_flag = 0;

    #---- 5.57.E - 2017/07/21 - There is a strange problem here. After an inhibit is over, sqlUp runs but since DownloadSWWin only
    #----  runs during iteration=1 - readDBCFile was setting $probe to /tmp/dbamon_mssql.pl. So, what was happening: sqlUp's remsh
    #----  call would fail because it was not running DownloadSWWin - and therefore looking for the wrong probe name (/tmp/...). So
    #----  it was coming here even though the remsh call failed, and generating an 801 event. This was even though the next iteration
    #----  would have corrected he probe name. The bottom line is that if the remsh call failed, why would we want to do an 801 event? 
    #----  The remsh call can issue it's own event if the probe fails. So - even though I fixed DownloadSWWin to not ever specify the
    #----  NG probe name, we don't want to ever have these 801's if the probe fails (the remsh call fails). I will add this first "if":

    if ($download_flag[$thishost] == 0)
    {
      &logit("Since the download_flag=$download_flag[$thishost] flag is False/0 - We do not want to do the DBA801 event check",$thishost);
    } 
    ###if ($t_mustbeup[$thishost] eq "Y")
    elsif ($t_mustbeup[$thishost] eq "Y")
    {
      $ev_cat = "Avail";
      &event("C",$thishost,"MSSQL Not Active: $dbstatus $dbmsg","MSSQLDown","DBA801",$probeout_file[$thishost]) unless $cluster_thisnodestatus[$thishost] eq "Passive";
    }
    else
    {
      $ev_cat = "Avail";
      &event("I",$thishost,"MSSQL Not Active: $dbstatus $dbmsg","MSSQLDown","DBA801",$probeout_file[$thishost]);
    }
  }
  else
  {
    $up[$thishost] = "Y";

    &logit("OK",$thishost);
    if ($agentstatus ne "UP" && $mssql_agentmon[$thishost] ne "N" && $mssql_edition[$thishost] !~ /exp/i)
    {
      $ev_cat = "Avail";
      &event("C",$thishost,"MSSQL Agent Service Not Active","AgentDown","DBA803C",$probeout_file[$thishost]) unless $cluster_thisnodestatus[$thishost] eq "Passive";
    }
    &metricsCurrent("sqlUp()",$thishost,"AGENT_STATUS",'',-1,'','',"Status=$agentstatus"); 
  }

  if ($os_mode[$thishost] eq "") 
  { 
    if    ($hw_model[$thishost] =~ /64/) { $os_mode[$thishost] = '64'; }
    elsif ($hw_model[$thishost] =~ /86/) { $os_mode[$thishost] = '32'; }
    else                                 { $os_mode[$thishost] = ''; }
  }

  if (! $hw_processors[$thishost]) { $hw_processors[$thishost] = 1; }

  #---- Optionally process MSSQL Svc Acct PW expiration
  &sqlUpSvcAcct;

  &logDetails($thishost,"<br><a name='sqlUpSERVER'> <h3>Server/OS Information</h3>");
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>OS Type:<td align=right>$f_s $os[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>OS Version:<td align=right>$f_s $os_version[$thishost] $os64bit[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>OS Mode:<td align=right>$f_s $os_mode[$thishost]<td>$f_s (32, 64 or Blank)");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Last Reboot:<td align=right>$f_s $os_last_reboot[$thishost]<td>$f_s");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Days Since Last Reboot:<td align=right>$f_s $os_days_since_last_reboot[$thishost]<td>$f_s");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Processor Type:<td align=right>$f_s $hw_model[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Processor Speed:<td align=right>$f_s $hw_clockspeedmhz[$thishost] MHz");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Processor Architecture:<td align=right>$f_s $cpu_arch (Bit)");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Server Memory Total (MB):<td align=right>$f_s $hw_memory[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Server Memory Available(MB):<td align=right>$f_s $mem_avail[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Server Memory % Used:<td align=right>$f_s ${mem_pct[$thishost]}%");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Server Processor Count:<td align=right>$f_s $hw_processors[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>NET IP Address:<td align=right>$f_s $net_ip[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>NET VLAN:<td align=right>$f_s $net_vlan[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>NET Company:<td align=right>$f_s $net_company[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>NET FQHostName:<td align=right>$f_s $fqhostname[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>NET ServerLoc:<td align=right>$f_s $serverloc[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>PERLPATH:<td align=right>$f_s $perlpath");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Target Shift:<td align=right>$f_s $target_shift[$thishost] <td>$f_s Current Work Shift: (P)rime, (W)eekend or (N)ight");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>ODBC Driver:<td align=right>$f_s $odbc_good_driver[$thishost] <td>$f_s The best one that DBAmon could find");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<br><a name='sqlUpINSTANCE'> <h3>MSSQL Instance Data</h3>");
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL Version:<td >$f_s $sw_version[$thishost] $mssql64bit[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL PatchLevel: <td >$f_s $mssql_patchlevel[$thishost]  <td>$f_s ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL Up?<td >$f_s $up[$thishost]<td>$f_s (Y or N)");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL Started:<td >$f_s $mssql_started <td>$f_s ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL Up For:<td align=right>$f_s $mssql_upfor_hours <td>$f_s (Hours)");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL Up For:<td align=right>$f_s $mssql_upfor_days[$thishost]  <td>$f_s (Days)");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s Total DB Count:<td align=right>$f_s $dbcount[$thishost]  <td>$f_s ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s Non-System DB Count:<td align=right>$f_s $udbcount[$thishost]  <td>$f_s ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL Software Edition: <td >$f_s $mssql_edition[$thishost]  <td>$f_s ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL License Type: <td >$f_s $mssql_licensetype[$thishost]  <td>$f_s ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL License Count: <td align=right>$f_s $mssql_numlicenses[$thishost]  <td>$f_s ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s DBMail Status: <td >$f_s $dbmail_status[$thishost]  <td>$f_s ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s Longest Currently Running DB Backup: <td align=right>$f_s $lrbackup_age_hrs[$thishost]  <td>$f_s (Hours) $lrbackup_message[$thishost] ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s Bad DB Parms Found (If Any): <td>$f_s $badparms[$thishost] <td>$f_s ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s TEMPDB Database File Count: <td align=right>$f_s $mssql_tempdb_dfcount[$thishost] <td>$f_s ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s LPIM On or OFF: <td >$f_s $this_lpim <td>$f_s (Whether <i>Lock Pages In Memory</i> is On or Off - 
    <br>A good article (from Glenn Berry at SQLServerPerformance): 
    <a href='http://sqlserverperformance.wordpress.com/2011/02/14/sql-server-and-the-lock-pages-in-memory-right-in-windows-server/'<b>Here</b></a>) ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL Config: Max Server Memory (MB): <td align=right>$f_s $sql_config_msm <td>$f_s ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL TCP Port: <td align=right>$f_s $mssql_sqlport[$thishost] <td>$f_s ");

  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL Replication Distributor?: <td >$f_s $mssql_repl_dist[$thishost] <td>$f_s (Y or Null)");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL Service Account: <td >$f_s $mssql_service_account[$thishost] <td>$f_s ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL Service Account PW Expiration Date: <td >$f_s $svcacct_pwexp_ts <td>$f_s ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL Service Account PW Expiration Days Until: <td align=right >$f_s $svcacct_pwexp_days <td>$f_s ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL DBMail Server: <td >$f_s $mssql_dbmail_server[$thishost] <td>$f_s ");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td><b>$f_s MSSQL AutoReorg Type: <td >$f_s $mssql_auto_reorg_type[$thishost] <td>$f_s ");

  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>CMDB Data (If Any)</h3>");
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>CMDB Contacts:<td>$f_s $star_contacts[$thishost] ");
  &logDetails($thishost,"</table><hr>");

  if ($ao_data) 
  {
    &logDetails($thishost,"<br><a name='sqlUpAO'> <h3>MSSQL AlwaysOn Readings </h3>");
    &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");

    &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
      <th>$f_s AO Parameter 
      <th>$f_s AO Value 
      ");
    
    &logDetails($thishost, $ao_data); 

    &logDetails($thishost,"</table><hr>");
  }

  if ($ssrs_logdata) 
  {
    &logDetails($thishost,"<br><a name='sqlUpSSRSLog'> <h3>MSSQL SSRS Log Data (ExectionLog2) </h3>");
    &logDetails($thishost, "The TOP 20 Rows of SSRS ExecutionLog2 Ordered by StartTime Descending <p>"); 
    &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
 
    ##print "DEBUG - ssrs_logdata=$ssrs_logdata\n"; 

    &logDetails($thishost, $ssrs_logdata) ; 

    &logDetails($thishost,"</table><hr>");
  }

  if ($dbfileperfdata) 
  {
    &logDetails($thishost,"<br><a name='sqlUpFILEPERF'> <h3>DB File Performance Data</h3>");
    &logDetails($thishost, "Ordered by NUM_TOTAL_IO Descending <p>"); 
    &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");

    &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
      <th>$f_s Rank
      <th>$f_s DB<br>Name
      <th>$f_s Logical FileName 
      <th>$f_s Physical FileName 
      <th>$f_s IO_Stall<br>_Read_MS
      <th>$f_s Num_Reads
      <th>$f_s AVG_Read<br>_Stall_MS
      <th>$f_s IO_Stall<br>_Write_MS
      <th>$f_s Num_Writes
      <th>$f_s AVG_Write<br>_Stall_MS
      <th>$f_s IO_Stalls
      <th>$f_s Num_Total_IO
      <th>$f_s AVG_IO<br>_Stall_MS ");
    
    &logDetails($thishost, $dbfileperfdata); 

    &logDetails($thishost,"</table><hr>");
  }

  if ($cluster_name[$thishost]) 
  {
    &logDetails($thishost,"<h3>Cluster Data</h3>");
    &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
    &logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
    &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Cluster Name:<td>$f_s $cluster_name[$thishost] ");
    &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Cluster Global Status:<td>$f_s $cluster_status[$thishost] ");
    &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Cluster On Node:<td>$f_s $cluster_onnode[$thishost] ");
    &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Cluster This-Node Status:<td>$f_s $cluster_thisnodestatus[$thishost] ");
    &logDetails($thishost,"</table><hr>");
  }

  if ($doubletake_status[$thishost]) 
  {
    &logDetails($thishost,"<h3>DoubleTake Data</h3>");
    &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
    &logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
    &logDetails($thishost,"<tr><td>$f_s <b>DoubleTake Status:<td>$f_s $doubletake_status[$thishost] ");
    &logDetails($thishost,"<tr><td>$f_s <b>DoubleTake Dir:<td>$f_s $doubletake_dir[$thishost] ");
    &logDetails($thishost,"<tr><td>$f_s <b>DoubleTake File:<td>$f_s $doubletake_file[$thishost] ");
    &logDetails($thishost,"<tr><td>$f_s <b>DoubleTake File Age Mins:<td>$f_s $doubletake_fileage_mins[$thishost] ");
    &logDetails($thishost,"</table><hr>");
  }

  if ($repl_www) 
  {
    &logDetails($thishost,"<br><a name='sqlUpREPL'> <h3>MSSQL Replication Status (For Distribution Servers Only)</h3>");
    &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
    &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
      <th>$f_s Subscription<br> Name <th>$f_s Subscription<br> Number<th>$f_s Last Replicated<br> Timestamp <th>$f_s Last Replicated<br> Hours Ago</tr>");
    &logDetails($thishost, $repl_www);
    &logDetails($thishost,"</table>");

      if    ($z_cmdcnt >= $t_repl_undist_cmds_c[$thishost]) { $z_replcolor = $color_bad; } 
      elsif ($z_cmdcnt >= $t_repl_undist_cmds_w[$thishost]) { $z_replcolor = $color_warn; } 

    if ($replcmds_www) 
    {
      &logDetails($thishost,"<h3>Replication Distribution Agents - Undistributed Command Counts</h3>");
      &logDetails($thishost,"DBC T_Repl_Undistributed_Cmds: Thresholds - W/C=$t_repl_undist_cmds_w[$thishost]/$t_repl_undist_cmds_c[$thishost]");
      &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
      &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
	<th>$f_trow Distribution<br> Agent Name 
        <th>$f_trow Undistributed<br>Command Count");
      &logDetails($thishost, $replcmds_www);
      &logDetails($thishost,"</table>");
    }
    &logDetails($thishost,"<hr>");
  }

  #---- CheckDB Scoreboard
  &logDetails($thishost,"<br><a name='sqlUpCheckDB'> <h3>MSSQL CheckDB Status</h3>");
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
  ##&logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Database <th>$f_s Date of Most Recent<br>Good ChecKDB<th>$f_s Days Ago<th>$f_s Status</tr>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s Database 
    <th>$f_s Most Recent<br>Successful CheckDB<br>Timestamp 
    <th>$f_s Most Recent<br>Successful CheckDB<br>Days Ago
    <th>$f_s Monitoring<br>Threshold<br>(Days) 
    <th>$f_s DB Flags<br>(If Any) 
    <th>$f_s Current <br> Status 
  </tr>");
  &logDetails($thishost,$checkdbdata);
  &logDetails($thishost,"</table><hr>");

  #---- Disk drive section
  &logDetails($thishost,"<br><a name='sqlUpDRIVE'> <h3>Disk Drive Data (Disks Which Contain MSSQL Database or TLog Files Belonging To This MSSQL Instance)</h3>");
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
  ##&logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Drive <th>$f_s Size (mB)<th>$f_s Used (mB)<th>$f_s Free (mB)<th>$f_s Percent Full</tr>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s Drive 
    <th>$f_s Size (MB)
    <th>$f_s Used (MB)
    <th>$f_s Free (MB)
    <th>$f_s Percent <br> Full
    <th>$f_s Warning <br>Threshold 
    <th>$f_s Critical <br> Threshold 
    <th>$f_s Current <br> Status 
  </tr>");
  &logDetails($thishost,$diskdrivedata);
  &logDetails($thishost,"</table><hr>");

  if ($rj_scoreboard)
  {
    &logDetails($thishost,"<br><a name='sqlUpRJ'> <h3>RJ Refresh Scoreboard</h3>");
    &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
    &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
      <th>$f_s RJ Target DBName 
      <th>$f_s Hours Since Last OK Refresh
      <th>$f_s DBC Threshold (If Any) 
    </tr>");
    &logDetails($thishost,$rj_scoreboard);
    &logDetails($thishost,"</table><hr>");
  }

  if ($hist_flag)
  {
    &logit("Creating tablespace history data in ${hstdir}/dbspaces/${filedate}",$thishost);
    system("sort $tmpflt >> ${hstdir}/dbspaces/${filedate} ");
  }

  #---- CheckDB Exceptions
  if ($checkdb_event_cnt > 0)
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 "$dashes\n";
    print TMPFL2 "$checkdb_event_data\n";
    print TMPFL2 "$dashes\n";
    close(TMPFL2);
    $ev_cat = "Mgmt";
    #---- Turned on 5.57.E 2017/07/21 - Warning sev for now
    &event("W",$thishost,"Found $checkdb_event_cnt Database(s) where Days Since Last Good CheckDB Exceeds Threshold of $t_checkdb_age_days[$thishost] (Days)","CheckDBAge","DBA808",$tmpfl2);
  }

  #---- Long running commands lrc 
  if ($mssql_lrc_cnt > 0)
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 "$dashes\n";
    print TMPFL2 "$mssql_lrc_data\n";
    print TMPFL2 "$dashes\n";
    close(TMPFL2);
    $ev_cat = "Perf";
    &event("U",$thishost,"Found $mssql_lrc_cnt Long Running SQL Command(s) during Weekday/PrimeShift","DayShiftLRC","DBA809",$tmpfl2);
  }

  #---- Old Perl processes
  if ($oldperl_cnt > 0)
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 "$dashes\n";
    print TMPFL2 "-- Report of Old Perl Processes Which Should Be Killed:\n";
    print TMPFL2 "$oldperl_details";
    print TMPFL2 "$dashes\n";
    print TMPFL2 "-- DOS Commands to Kill These Processes:\n";
    print TMPFL2 "$oldperl_kill";
    print TMPFL2 "$dashes\n";
    print TMPFL2 "-- List of PIDs to Kill:\n";
    print TMPFL2 "$oldperl_pids";
    print TMPFL2 "$dashes\n";
    ##print TMPFL2 `cat $probeout_file[$thishost]`;
    close(TMPFL2);
    $ev_cat = "Perf";
    &event("C",$thishost,"$oldperl_cnt Old Perl process(es) found - Max process age: $oldperl_maxage hours - Threshold: 12 hours","PerlOldProc","DBA802",$tmpfl2);
  }

  #---- Process SWVER data to see if we are running the right version of SQL
  foreach $this_entry (@swver_data)
  {
    next if $this_entry !~ /^$dbmsout[$thishost]/;
    @words = split(/ /,$this_entry);
    $this_family = $words[1];
    $this_minver = $words[2];
    $this_kbnum  = $words[3];
    ##print "$titleraw[$thishost] $sw_version[$thishost] - Found this_family=$this_family this_minver=$this_minver\n";

    #---- Continue only if this is OUR family
    next if $sw_version[$thishost] !~ /^$this_family/;

    $z = length($this_minver);
    ##print "  z=$z \n";
    if (substr($sw_version[$thishost],0,$z) lt $this_minver)
    {
      $ev_cat = "Mgmt";
      &event("U",$thishost,"$dbmsout[$thishost] Version $sw_version[$thishost] is older than the minimum 'good' version ($this_minver/$this_kbnum) for this family ($this_family)","SWVER-OldVer","DBA652");
      last;
    }
  }

  #---- TLOG stuff
  # print "$P TLOG: $dbname $trunc $size $pctused $this_drive_letter $this_drive_pctused $dbp_log_fname $dbp_log_space\n";
  # dbamon_mssql.pl TLOG: master Yes 1.24 48.86 E 80.56 E:\\MSSQL7\\data\\mastlog.ldf Unlimited
  foreach (split('\n',$tlogdata[$thishost]))
  {
    @words = split;
    $tl_dbname   = $words[2]; 
    $tl_trunc    = $words[3]; 
    $tl_tlsize   = $words[4]; 
    $tl_pctused  = $words[5]; 
    $tl_drive    = $words[6]; 
    $tl_drivepct = $words[7]; 
    $tl_filename = $words[8]; 
    $tl_growth   = $words[9]; 
    $tl_lrwd     = $words[10]; 

    #---- dbsize{} includes the tlog size - subtract out - tl_dbsize will be the size of the db only
    #---- WAIT!!! This is wrong - DBSIZE cannot be calculated by just subracting the size of ONE 
    #----   TLOG because there could be many. 
    ##$tl_dbsize   = sprintf "%.2f",($dbsize{$tl_dbname}) - $tl_tlsize;
    $tl_dbsize   = sprintf "%.2f",($dbsize{$tl_dbname});

    ##$tl_ratio    = sprintf "%.2f",($tl_tlsize / $tl_dbsize) if $tl_dbsize > 0;

    $db_info_tl_trunc[$thishost]{$tl_dbname} = $tl_trunc; 

    $db_info_tl_dbsize[$thishost]{$tl_dbname} = $tl_dbsize; 
    $db_info_tl_tlsize[$thishost]{$tl_dbname} = $tl_tlsize; 

    #---- This didn't make sense to have the logic here since we're only looking at 1 TLOG file - A DB can have many TLOG files
    #----   many lines removed.
  }

  #---- If there aren't any user dbs, warning event 
  &metricsCurrent("sqlUp()",$thishost,"NON_SYSTEM_DB_COUNT","",$udbcount[$thishost],"",0,"Event if Zero"); 
  $ev_cat = "Mgmt";
  &event("U",$thishost,"Non-System DB Count is Zero","No-User-DBs","DBA663") if $udbcount[$thishost] ne "" && $udbcount[$thishost] == 0 && $up[$thishost] eq "Y";

  #---- U event if any DBs are RESTORING 
  if ($dbs_restoring > 0)
  {
    $ev_cat = "Avail";
    &event("U",$thishost,"$dbs_restoring DB(s) In RESTORING State","DBs-Restoring","DBA671"); 
  }
  if ($dbs_offline > 0)
  {
    $ev_cat = "Mgmt";
    &event("U",$thishost,"$dbs_offline DB(s) In OFFLINE State","DBs-Offline","DBA671"); 
  }

  #---- DBs with incorrect DB owner?
  if ($db_owner_counter > 0 && $g_sql_db_owner_event eq "Y")
  {
    #chop($date = `date +%Y/%m/%d-%H:%M:%S`);
    $date = &getdate; 
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 "
-- =================================================================
--   SQL To Correct DB Names (Generated: $date):
-- =================================================================
";
    print TMPFL2 " \n";
    print TMPFL2 "-- Section A: SQL To CHANGE: \n";
    print TMPFL2 " \n";
    print TMPFL2 "$db_owner_fix";
    print TMPFL2 " \n";
    print TMPFL2 "-- Section B: SQL To ROLLBACK (Commented): \n";
    print TMPFL2 " \n";
    print TMPFL2 "$db_owner_rollback";
    close(TMPFL2);

    $ev_cat = "Mgmt";
    &event("U",$thishost,"DB Owner - Found $db_owner_counter DB(s) with Incorrect DB OWNER (Owner should be $db_good_owner)","DB-Owner=$db_owner_counter","DBA353",$tmpfl2);
  }

  #---- DBs with missing GOODPARMs? 
  if ($missing_goodparms ne "") 
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 $missing_goodparms; 
    close(TMPFL2);

    $ev_cat = "Perf";
    &event("P",$thishost,"Database(s) Found With GOOD-For-Performance Options Set to OFF","GoodDBOptions-Missing","DBA861",$tmpfl2);
  }

  #---- Repl DA's with Non-Default profile
  if ($mssql_repl_nda ne "") 
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 $mssql_repl_nda; 
    close(TMPFL2);

    $ev_cat = "Mgmt";
    &event("W",$thishost,"Replication Distribution Agent(s) Found Using Non-Default Agent Profile","Repl-DA-ND-Profile","DBA862",$tmpfl2);
  }

  #---- DB's with >1 TLOG File
  if ($tlogmultifile_cnt > 0) 
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 $tlogmultifile_data; 
    close(TMPFL2);

    $ev_cat = "Mgmt";
    &event("U",$thishost,"Found $tlogmultifile_cnt Database(s) with Multi-File TLOGs","Multi-File-TLOGs","DBA946",$tmpfl2);
  }

  #---- Long running SQL Jobs
  if ($lr_jobs ne "") 
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 $lr_jobs; 
    close(TMPFL2);

    $ev_cat = "Perf";
    &event("U",$thishost,"Found $lr_job_cnt Long Running SQL Job(s)","LongRunningSQLJobs=$lr_job_cnt","DBA943",$tmpfl2);
  }

  #---- Auto Reorg Age 
  if ($autoreorg_cnt > 0) 
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 $autoreorg_data; 
    close(TMPFL2);

    $ev_cat = "Perf";
    &event("W",$thishost,"Found $autoreorg_cnt Database(s) Requiring Auto-Reorg/Reindex","AutoReorgAgeDBs=$autoreorg_cnt","DBA951",$tmpfl2);
  }

  #---- SSRS Failed Reports
  if ($#ssrs_failed_reports > -1) 
  {
    my $ssrs_failed_job_cnt = $#ssrs_failed_reports + 1; 
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 "The following SSRS Report(s) have failed since the last DBAmon iteration:\n\n";
    foreach $this_report (@ssrs_failed_reports)
    {
      print TMPFL2 $this_report; 
    }
    print TMPFL2 "\nRun this on the target for additional details: SELECT * FROM ReportServer..ExecutionLog2\n";
    close(TMPFL2);

    $ev_cat = "Mgmt";
    &event("C",$thishost,"Found $ssrs_failed_job_cnt Unsuccessful SSRS Report(s)","SSRSFailedReports=$ssrs_failed_job_cnt","DBA933",$tmpfl2);
  }

  #---- Bad logins - defalt DB missing 
  if ($login_missingdefdb_cnt > 0)  
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 "-- SQL to correct the default DB for these $login_missingdefaultdb_cnt Logins:\n\n";
    print TMPFL2 "USE [master]\nGO\n"; 
    foreach $zlogin (sort keys %login_missingdefdb) 
    {
      $zdb = $login_missingdefdb{$zlogin}; 
      ##print "DEBUG - zlogin=$zlogin zdb=$zdb\n"; 
      print TMPFL2 "-- Login $zlogin current has default DB of non-existent: $zdb\n"; 
      print TMPFL2 "ALTER LOGIN [$zlogin] WITH DEFAULT_DATABASE=[master];\n"; 
    }
    print TMPFL2 "GO\n"; 
    close(TMPFL2);

    $ev_cat = "Mgmt";
    &event("W",$thishost,"Found $login_missingdefdb_cnt SQL Login(s) Where Default DB Does Not Exist","SQLLoginMissingDefDB=$login_missingdefdb_cnt","DBA904",$tmpfl2);
  }


  #---- Obsolete
  ## &histCreate("sqlUp()",$thishost,"SERVER_MEM",".",$mem_pct[$thishost], $ram[$thishost], $mem_used[$thishost]) if $mem_pct[$thishost] && $ram[$thishost];
  ## &histCreate("sqlUp()",$thishost,"SERVER_CPU","BusyWithSQL", $cpu_busy_with_sql[$thishost]) if $cpu_busy_with_sql[$thishost] > 0;

  #---- Log any needed metric history rows
  #($caller, $h, $c, $p, $v, $v2, $v3) = @_;
  &metricsInsert("sqlUp()",$thishost,"SERVER_MEM_PCT",".",$mem_pct[$thishost]);
  &metricsInsert("sqlUp()",$thishost,"SERVER_MEM_TOT",".",$ram[$thishost]);
  &metricsInsert("sqlUp()",$thishost,"SERVER_MEM_USED",".",$mem_used[$thishost]);

  &metricsCurrent("sqlUp()",$thishost,"SERVER_MEM_PCR","" ,$mem_pct[$thishost] ,"" ,"" ,"Percent of Server RAM In Use"); 

  &metricsInsert("sqlUp()",$thishost,"S_CPU_BUSY_SQL",".",$cpu_busy_with_sql[$thishost]) if $cpu_busy_with_sql[$thishost] > 0;

  &metricsCurrent("sqlUp()",$thishost,"S_CPU_BUSY_SQL","" ,$cpu_busy_with_sql[$thishost] ,"" ,"" ,"Percent CPU Util. by SQL "); 

  &metricsInsert("sqlUp()",$thishost,"TLOG_DBS_NOT_SIMPLE","." ,$dbs_not_simple[$thishost]) if $dbs_not_simple[$thishost] > 0; 

  #---- Replication Stuff 
  if ($repl_max_lag_hrs > -99) 
  {
    $perf_readings[$thishost]{"SQL_Repl_Max_Lag_Hrs"} = $repl_max_lag_hrs; 
  }

  if ($perf_readings[$thishost]{"SQL_REPL_MAX_UNDIST_CMDS"} > -1 && $t_repl_undist_cmds_w[$thishost] > 0) 
  {
    $z_replval = $perf_readings[$thishost]{"SQL_REPL_MAX_UNDIST_CMDS"}; 
    ##print "DEBUG - z_replval=$z_replval\n"; 

    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 "<table border=0 bgcolor=$table_bgcolor>
<tr bgcolor=$table_headbgcolor> <th>$f_s Distribution<br> Agent Name <th>$f_s Undistributed<br>Command Count
$replcmds_www
</table>
DBC Parm: <b>T_Repl_Undistributed_Cmds:</b> Thresholds - W/C=$t_repl_undist_cmds_w[$thishost]/$t_repl_undist_cmds_c[$thishost]"; 
    close(TMPFL2);

    if    ($z_replval >= $t_repl_undist_cmds_c[$thishost]) 
    { 
      &event("C",$thishost,"Too Many Undistributed Replication Commands - Critical Threshold of ($t_repl_undist_cmds_c[$thishost]) Exceeded","MSSQL_Repl_Cmds","DBA863", $tmpfl2);
    } 
    elsif ($z_replval >= $t_repl_undist_cmds_w[$thishost]) 
    { 
      &event("W",$thishost,"Too Many Undistributed Replication Commands - Warning Threshold of ($t_repl_undist_cmds_w[$thishost]) Exceeded","MSSQL_Repl_Cmds","DBA863", $tmpfl2);
    } 
  }

  #---- DoubleTake stuff
  if ($is_threshold[$thishost] > 0)
  {
    if ($doubletake_fileage_mins[$thishost]  == 999999)
    {
      $ev_cat = "Avail";
      &event("C",$thishost,"InSync: DoubleTake File $doubletake_file[$thishost] is MISSING","InSyncAge","DBA665",$probeout_file[$thishost]);
    }
    elsif ($doubletake_fileage_mins[$thishost] > $is_threshold[$thishost])
    {
      $ev_cat = "Perf";
      &event("C",$thishost,"InSync: DoubleTake File Age: $doubletake_fileage_mins[$thishost] (Min.) exceeds threshold of $is_threshold[$thishost] (Min.)","InSyncAge","DBA665",$probeout_file[$thishost]);
    }

    if ($doubletake_status[$thishost] !~ /Running/)
    {
      $ev_cat = "Avail";
      &event("C",$thishost,"InSync: DoubleTake Server is NOT Running (Status: $doubletake_status[$thishost]","InSyncDown","DBA665",$probeout_file[$thishost]);
    }
  }

  #---- Process ACTIVE TRANS 
  &logDetails($thishost,"<br><a name='sqlUpTRANS'> <h3>MSSQL Active Transactions (If Any)</h3>");
  my $tran_heading = "(TranDurThresholdHours=$dbc_parm[$thishost]{'mssql_tran_duration_hrs'} TranTLOGThresholdGB=$dbc_parm[$thishost]{'mssql_tran_tlog_gb'})"; 
  &logDetails($thishost,"$tran_heading");
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");

  #---- Active trans monitoring and SNAPSHOT
  if ($trans_flag)    #---- If we did find any DDP ACTIVE TRANS data above
  {
    my $debug_tran  = 0; 

    my $sn_key = &snapshotsKeyGen("MSSQL_Active_Trans"); 
    &snapshotsInsert($thishost, $sn_key, 0, "MSSQL Active Transactions $tran_heading"); 

    my $table_heading = "<tr bgcolor=$table_headbgcolor>
      <th>$f_s SPID 
      <th>$f_s Trans.<br>Dur.<br>(Mins) 
      <th>$f_s Trans.<br>Dur.<br>(Hrs) 
      <th>$f_s TLOG.<br>MB<br>(Rsvd) 
      <th>$f_s TLOG.<br>MB<br>(Used) 
      <th>$f_s Trans.<br>Begin<br>Timestamp
      <th>$f_s Session<br>Hostname 
      <th>$f_s Session<br>Program<br>Name 
      <th>$f_s Session<br>Command/<br>Status
      <th>$f_s Session<br>Blocked?
      <th>$f_s Session<br>WaitTime<br>(MS)
      <th>$f_s Session<br>Win<br>Login
      <th>$f_s Session<br>SQL<br>Login
      <th>$f_s Session<br>CPU
      <th>$f_s Session<br>Physical<br>I/O
      <th>$f_s Trans.<br>State
      <th>$f_s Trans.<br>Type
    </tr>";

    &logDetails($thishost, $table_heading ); 
    &snapshotsInsert($thishost, $sn_key, 1, $table_heading); 
    my $sn_seq = 1; 

    if ($debug_tran) 
    {
      print "DEBUG_TR: p_hrs=($dbc_parm[$thishost]{'mssql_tran_duration_hrs'})\n"; 
      print "DEBUG_TR:  p_gb=($dbc_parm[$thishost]{'mssql_tran_tlog_gb'})\n"; 
    }
    
    my $tr_cnt_time = 0; 
    my $tr_cnt_size = 0; 

    foreach $this_line (split('\n',$sqltrans_data[$thishost]))
    {
      &packetParse($this_line) if $this_line =~ /^DDP:/;
      $pa_counter = -1;
      foreach $this_field (@pa_words)
      {
	$pa_counter++;
	print "DEBUG_PA: pa_words[$pa_counter]=($this_field)\n" if $debug_tran == 1;
	$this_verb = (split(/\=/,$this_field)) [0];
	$this_noun = (split(/\=/,$this_field)) [1];

	#---- Remove leading and trailing quotes from data field (after = sign)
	$this_noun =~ s/^'//;
	$this_noun =~ s/'$//;

	$trans_data{$this_verb} = $this_noun;
      }

      #---- Process THIS JOB
      print "DEBUG_TRAN: tr_spid=$trans_data{'tr_spid'} tr_trans_run_hrs=$trans_data{'tr_trans_run_hrs'} tr_tlog_mb_rsvd=$trans_data{'tlog_mb_rsvd'}\n" if $debug_tran ;

      #---- Save MAX values
      $tr_max_dur_hrs = $trans_data{'tr_trans_run_hrs'}; 
      $tr_max_tlog_gb = int($trans_data{'tr_tlog_mb_rsvd'} / 1024); 

      #---- Test against both thresholds
      my $tr_color = "lime"; 
      if ($trans_data{'tr_trans_run_hrs'} >= $dbc_parm[$thishost]{'mssql_tran_duration_hrs'}) 
      {
        $tr_cnt_time++; 
        $tr_color = "pink"; 
      }
      if ($trans_data{'tr_tlog_mb_rsvd'} >= ($dbc_parm[$thishost]{'mssql_tran_tlog_gb'} * 1024))
      {
        $tr_cnt_size++; 
        $tr_color = "pink"; 
      }

      #---- DDP:<|>dbamon_mssql.pl<|>TRANS_ACTIVE:<|>tr_dbname='bbtest'<|>tr_db_trans_begin_time='2013-04-21 07:18:47.463'<|>tr_hostname='LTDELL2012'<|>tr_program_name='Microsoft SQL Server Management Studio -'<|>tr_spid='58'<|>tr_s    ysprocesses_cmd='AWAITING COMMAND'<|>tr_tlog_mb_rsvd='1'<|>tr_tlog_mb_used='1'<|>tr_transid='3886334'<|>tr_transstate='4:Trans Run w/Log Data'<|>tr_transtype='1:Read/Write'<|>tr_trans_run_hrs='8'<|>tr_trans_run_mins='472    '<|>tr_wttim_ms='0'<|>tr_cpu='875'<|>tr_physical_io='111'<|>
      #---- WWW Details Line
      my $table_row = "<tr bgcolor=$tr_color>
	<td>             $f_s   $trans_data{'tr_spid'} 
	<td align=right> $f_s   $trans_data{'tr_trans_run_mins'}
	<td align=right> $f_s   $trans_data{'tr_trans_run_hrs'}
	<td align=right> $f_s   $trans_data{'tr_tlog_mb_rsvd'}
	<td align=right> $f_s   $trans_data{'tr_tlog_mb_used'}
	<td nowrap>      $f_s   $trans_data{'tr_db_trans_begin_time'}
	<td>             $f_s   $trans_data{'tr_hostname'}
	<td>             $f_s   $trans_data{'tr_program_name'}
	<td>             $f_s   $trans_data{'tr_sysprocesses_cmd'}
	<td align=right> $f_s   $trans_data{'tr_blocked'}
	<td align=right> $f_s   $trans_data{'tr_wttim_ms'}
	<td>             $f_s   $trans_data{'tr_sysprocesses_nt_username'}
	<td>             $f_s   $trans_data{'tr_sysprocesses_loginame'}
	<td align=right> $f_s   $trans_data{'tr_cpu'}
	<td align=right> $f_s   $trans_data{'tr_physical_io'}
	<td>             $f_s   $trans_data{'tr_transstate'}
	<td>             $f_s   $trans_data{'tr_transtype'}
      ";
      &logDetails($thishost, $table_row); 
      &snapshotsInsert($thishost, $sn_key, ++$sn_seq, $table_row); 
    } 

    #---- See if we have any LONG TLOG events (time or space)
    my $tr_reason = ""; 
    if ($tr_cnt_size > 0) 
    {
      $tr_reason .= "($tr_cnt_size Trans using at least $dbc_parm[$thishost]{'mssql_tran_tlog_gb'} GB of TLOG Space)"; 
    } 
    if ($tr_cnt_time > 0) 
    {
      $tr_reason .= "($tr_cnt_time Trans running for at least $dbc_parm[$thishost]{'mssql_tran_duration_hrs'} Hours)"; 
    } 

    #---- MAX Dur and TLOG GB for active trans
    $perf_readings[$thishost]{"SQL_MaxTran_Duration_Hrs"} = $tr_max_dur_hrs; 
    $perf_readings[$thishost]{"SQL_MaxTran_TLOG_GB"}      = $tr_max_tlog_gb; 

    if ($tr_reason ne "") 
    {
      open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
      print TMPFL2 "For details, view the Instance Snapshot reports at: $ss_url[$thishost]\n";
      close(TMPFL2);
      $ev_cat = "Perf";
      &event("U",$thishost,"Large DB Transaction(s): $tr_reason","TransLarge","DBA944", $tmpfl2);
    }

  }    #---- End of IF $TRANS_FLAG
  &logDetails($thishost,"</table><hr>");

  #---- ActiveSes SNAPSHOT
  if ($activeses_flag)    #---- If we did find any DDP ACTIVE SESSIONS data above
  {
    my $debug_activeses = 0; 

    my $sn_key = &snapshotsKeyGen("MSSQL_Active_Sessions"); 
    &snapshotsInsert($thishost, $sn_key, 0, "MSSQL Active Sessions"); 
    print "Hit1\n" if $debug_activeses;

    my $table_heading = "<tr bgcolor=$table_headbgcolor>
      <th>$f_s SPID 
      <th>$f_s Session<br>Hostname 
      <th>$f_s Session<br>Database
      <th>$f_s Session<br>Program<br>Name 
      <th>$f_s Session<br>Command/<br>Status
      <th>$f_s Session<br>Blocked?
      <th>$f_s Session<br>WaitTime<br>(MS)
      <th>$f_s Session<br>Last<br>Wait<br>Type 
      <th>$f_s Session<br>Wait<br>Resource 
      <th>$f_s Session<br>Status
      <th>$f_s Session<br>SQL<br>Login
      <th>$f_s Session<br>Win<br>Login
      <th>$f_s Session<br>CPU
      <th>$f_s Session<br>Physical<br>I/O
      <th>$f_s Session<br>Memusage<br>
      <th>$f_s Session<br>Logged In<br>Minutes
    </tr>";

    &snapshotsInsert($thishost, $sn_key, 1, $table_heading); 
    print "Hit2\n" if $debug_activeses;
    my $sn_seq = 1; 

    foreach $this_line (split('\n',$activeses_data[$thishost]))
    {
      &packetParse($this_line) if $this_line =~ /^DDP:/;
      $pa_counter = -1;
      foreach $this_field (@pa_words)
      {
	$pa_counter++;
	print "DEBUG_PA: pa_words[$pa_counter]=($this_field)\n" if $debug_tran == 1;
	$this_verb = (split(/\=/,$this_field)) [0];
	$this_noun = (split(/\=/,$this_field)) [1];

	#---- Remove leading and trailing quotes from data field (after = sign)
	$this_noun =~ s/^'//;
	$this_noun =~ s/'$//;

	$activeses_entries{$this_verb} = $this_noun;
      }

      print "DEBUG_TRAN: sn_spid=$activeses_entries{'sn_spid'} sn_waittime=$activeses_entries{'sn_waittime'}\n" if $debug_activeses ;

      #----  DDP:<|>dbamon_mssql.pl<|>SNAP_SES_ACTIVE:<|>sn_blocked='0'<|>sn_cmd='WAITFOR'<|>sn_cpu='0'<|>sn_dbname='master'<|>sn_hostname='LTDELL2012'<|>sn_logged_in_mins='1'<|>sn_loginame='LTDELL2012    \mssql'<|>sn_memusage='3'<|>sn_nt_username='mssql'<|>sn_open_tran='0'<|>sn_physical_io='0'<|>sn_program_name='Microsoft SQL Server Management Studio - Query'<|>sn_spid='63'<|>sn_status='su    spended'<|>sn_waitresource=''<|>sn_waittime='43540'<|>

      #---- WWW Details Line
      my $as_color = "lime"; 
      if ($activeses_entries{'sn_waittime'} > 0) { $as_color = "pink"; }

      my $table_row = "<tr bgcolor=$as_color>
	<td>             $f_s   $activeses_entries{'sn_spid'} 
	<td>             $f_s   $activeses_entries{'sn_hostname'}
	<td>             $f_s   $activeses_entries{'sn_dbname'}
	<td>             $f_s   $activeses_entries{'sn_program_name'}
	<td>             $f_s   $activeses_entries{'sn_cmd'}
	<td>             $f_s   $activeses_entries{'sn_blocked'}
	<td align=right> $f_s   $activeses_entries{'sn_waittime'}
	<td>             $f_s   $activeses_entries{'sn_lastwaittype'}
	<td>             $f_s   $activeses_entries{'sn_waitresource'}
	<td>             $f_s   $activeses_entries{'sn_status'}
	<td>             $f_s   $activeses_entries{'sn_loginame'}
	<td>             $f_s   $activeses_entries{'sn_nt_username'}
	<td align=right> $f_s   $activeses_entries{'sn_cpu'}
	<td align=right> $f_s   $activeses_entries{'sn_physical_io'}
	<td align=right> $f_s   $activeses_entries{'sn_memusage'}
	<td align=right> $f_s   $activeses_entries{'sn_logged_in_mins'}
      ";
      &snapshotsInsert($thishost, $sn_key, ++$sn_seq, $table_row); 
      print "Hit3 sn_key=$sn_key\n" if $debug_activeses;
    } 

    #---- See if we have any LONG TLOG events (time or space)
    my $tr_reason = ""; 
    if ($tr_cnt_size > 0) 
    {
      $tr_reason .= "($tr_cnt_size Trans using at least $dbc_parm[$thishost]{'mssql_tran_tlog_gb'} GB of TLOG Space)"; 
    } 
    if ($tr_cnt_time > 0) 
    {
      $tr_reason .= "($tr_cnt_time Trans running for at least $dbc_parm[$thishost]{'mssql_tran_duration_hrs'} Hours)"; 
    } 

    #---- MAX Dur and TLOG GB for active trans
    $perf_readings[$thishost]{"SQL_MaxTran_Duration_Hrs"} = $tr_max_dur_hrs; 
    $perf_readings[$thishost]{"SQL_MaxTran_TLOG_GB"}      = $tr_max_tlog_gb; 

    if ($tr_reason ne "") 
    {
      open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
      print TMPFL2 "For details, view the Instance Snapshot reports at: $ss_url[$thishost]\n";
      close(TMPFL2);
      $ev_cat = "Perf";
      &event("U",$thishost,"Large DB Transaction(s): $tr_reason","TransLarge","DBA944", $tmpfl2);
    }

  }    #---- End of IF $ACTIVESES_FLAG

  #---- One last drilldown section
  &sqlUpMissingIndexes;

  #---- CPUProcess SNAPSHOT
  if ($cpuprocess_flag)    #---- If we did find any DDP CPU Process entries
  {
    &sqlUpSnapCPUProcess;
  }

  #---- MemTop SNAPSHOT
  if ($memprocess_flag)    #---- If we did find any DDP CPU Process entries
  {
    &sqlUpSnapMemTop;
  }

  #---- MemTop SNAPSHOT
  if ($topwaits_data[$thishost] ne "")    #---- If we did find any DDP CPU Process entries
  {
    &sqlUpSnapTopWaits;
  }

  #---- AO Status SNAPSHOT
  if ($aoprocess_flag)    #---- If we did find any DDP CPU Process entries
  {
    &sqlUpSnapAO;
  }

  #---- Missing indexes 
  #if ($sqlmissingindexes_flag)    #---- If we did find any DDP CPU Process entries
  #{
  #  &sqlUpMissingIndexes;
  #}

  #---- Debug
  #---- Debug
  #print "DEBUG windows_domain[$thishost]=($windows_domain[$thishost])\n"; 

  #---- Userexit - POST
  if (-x "/opt/dbamon/bin/userexit/inc_sqlup")
  {
    if (! $inc_userexit)
    {
      #---- Moved to main
      $inc_userexit = 1;
    }
    require "inc_sqlup"; 
    &inc_sqlup;
  }
}
#-----------------------------------------------------------------------------
#---- End of sqlUp
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
sub sqlUpSvcAcct
#-----------------------------------------------------------------------------
{
  #---- Optionally process MSSQL Svc Acct PW expiration
  if ($config_parm{'mssql_svc_acct_check'} eq "Y" && $mssql_service_account[$thishost] ne "") 
  {
    my $debug_ac       = 0; 
    my $svcacct_t_warn = 60;
    my $svcacct_t_crit = 30;
    my $svcacct_ts     = "??";

    my ($svcacct_return, $svcacct_ts) = &sqlSvcAcctSelect($mssql_service_account[$thishost]); 
    print "After select, svcacct_return=$svcacct_return svcacct_ts=$svcacct_ts\n" if $debug_ac; 

    if ($svcacct_return > -999999)    #---- Do we have a valid value?
    {
      #---- Just in case
      open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
      print TMPFL2 "Service Account:          $mssql_service_account[$thishost]\n";
      print TMPFL2 "Date When PW Will Expire: $svcacct_ts\n";
      print TMPFL2 "Days Until PW Expiration: $svcacct_return\n";
      print TMPFL2 "Warning Threshold:        $svcacct_t_warn (Days)\n";
      print TMPFL2 "Critical Threshold:       $svcacct_t_crit (Days)\n";
      close(TMPFL2);

      if ($svcacct_return <= $svcacct_t_crit)  #---- Are we at or below the CRITICAL threshold (days)?
      {
        print "CRIT event\n" if $debug_ac; 
        $ev_cat = "Avail";
        &event("C",$thishost,"MSSQL SvcAcct=$mssql_service_account[$thishost] Exception - Password Will Expire LE $svcacct_t_crit Days","SvcAcctPWExp","DBA945", $tmpfl2);
      } 
      elsif ($svcacct_return <= $svcacct_t_warn)  #---- Are we at or below the WARNING threshold (days)?
      {
        print "WARN event\n" if $debug_ac; 
        $ev_cat = "Avail";
        &event("W",$thishost,"MSSQL SvcAcct=$mssql_service_account[$thishost] Exception - Password Will Expire LE $svcacct_t_warn Days","SvcAcctPWExp","DBA945", $tmpfl2);
      }
      else
      {
        print "NO event\n" if $debug_ac; 
      }
      #---- For WWW output above
      $svcacct_pwexp_ts   = $svcacct_ts;
      $svcacct_pwexp_days = $svcacct_return;
    }
  }
}

# -----------------------------------------------------------------------------
sub sqlUpSnapCPUProcess
# -----------------------------------------------------------------------------
{
  my $debug_cpuprocess = 0; 

  my $sn_key = &snapshotsKeyGen("Windows_Processes_Using_CPU"); 
  &snapshotsInsert($thishost, $sn_key, 0, "Windows Active Processes - Using at Least 10 Percent of a CPU"); 
  print "Hit1\n" if $debug_cpuprocess;

  my $table_heading = "<tr bgcolor=$table_headbgcolor>
    <th>$f_s Windows<br>Process ID 
    <th>$f_s Windows<br>Process Name 
    <th>$f_s CPU<br>% 
    <th>$f_s Windows<br>Process<br>Private Bytes
    <th>$f_s Windows<br>Process<br>Age
  </tr>";

  &snapshotsInsert($thishost, $sn_key, 1, $table_heading); 
  print "Hit2\n" if $debug_cpuprocess;
  my $sn_seq = 1; 

  foreach $this_line (split('\n',$cpuprocess_data[$thishost]))
  {
    &packetParse($this_line) if $this_line =~ /^DDP:/;
    $pa_counter = -1;
    foreach $this_field (@pa_words)
    {
      $pa_counter++;
      print "DEBUG_PA: pa_words[$pa_counter]=($this_field)\n" if $debug_cpuprocess == 1;
      $this_verb = (split(/\=/,$this_field)) [0];
      $this_noun = (split(/\=/,$this_field)) [1];

      #---- Remove leading and trailing quotes from data field (after = sign)
      $this_noun =~ s/^'//;
      $this_noun =~ s/'$//;

      $cpuprocess_entries{$this_verb} = $this_noun;
    }

    print "DEBUG_TRAN: sn_spid=$cpuprocess_entries{'sn_name'} sn_waittime=$cpuprocess_entries{'sn_waittime'}\n" if $debug_cpuprocess ;

    #---- DEBUG_PA: pa_words[2]=(sn_process_name='perl#2') DEBUG_PA: pa_words[3]=(sn_cpu_pct='97') DEBUG_PA: pa_words[4]=(sn_private_bytes='25632768') DEBUG_PA: pa_words[5]=(sn_elapsed_seconds='10') DEBUG_PA: pa_words[6]=(sn_process_desc='')

    #---- WWW Details Line
    my $zage = $cpuprocess_entries{'sn_elapsed_seconds'};
    my $zage_out = ""; 

    if    ($zage <  3600) { $zage_out = sprintf("%.2f", $zage / 60 )   . " Minutes"; }
    elsif ($zage < 86400) { $zage_out = sprintf("%.2f", $zage / 3600)  . " Hours"; }
    else                  { $zage_out = sprintf("%.2f", $zage / 86400) . " Days"; }
    
    if    ($cpuprocess_entries{'sn_cpu_pct'} >= 75) { $cp_color = "pink"; }
    elsif ($cpuprocess_entries{'sn_cpu_pct'} >= 50) { $cp_color = "orange"; }
    else                                            { $cp_color = "yellow"; }

    my $table_row = "<tr bgcolor=$cp_color>
      <td align=right> $f_s   $cpuprocess_entries{'sn_id_process'} 
      <td>             $f_s   $cpuprocess_entries{'sn_process_name'} 
      <td align=right> $f_s   $cpuprocess_entries{'sn_cpu_pct'}
      <td align=right> $f_s   $cpuprocess_entries{'sn_private_bytes'}
      <td align=left>  $f_s   $zage_out 
    ";
    &snapshotsInsert($thishost, $sn_key, ++$sn_seq, $table_row); 
    print "Hit3 sn_key=$sn_key\n" if $debug_cpuprocess;
  } 
}

# -----------------------------------------------------------------------------
sub sqlUpSnapMemTop
# -----------------------------------------------------------------------------
{
  my $debug_memtop = 0; 

  my $sn_key = &snapshotsKeyGen("Windows_Top_Memory_Consumers"); 
  &snapshotsInsert($thishost, $sn_key, 0, "Windows Top 5 Memory Consuming Processes"); 
  ##print "Hit1\n" if $debug_memtop;

  my $table_heading = "<tr bgcolor=$table_headbgcolor>
    <th>$f_s Windows<br>Process Name 
    <th>$f_s Windows<br>Process PID 
    <th>$f_s Windows<br>Process<br>Working Set Size MB
  </tr>";

  &snapshotsInsert($thishost, $sn_key, 1, $table_heading); 
  ##print "Hit2\n" if $debug_memtop;
  my $sn_seq = 1; 

  foreach $this_line (split('\n',$memprocess_data[$thishost]))
  {
    &packetParse($this_line) if $this_line =~ /^DDP:/;
    $pa_counter = -1;
    foreach $this_field (@pa_words)
    {
      $pa_counter++;
      print "DEBUG_MT1: pa_words[$pa_counter]=($this_field)\n" if $debug_memtop == 1;
      $this_verb = (split(/\=/,$this_field)) [0];
      $this_noun = (split(/\=/,$this_field)) [1];

      #---- Remove leading and trailing quotes from data field (after = sign)
      $this_noun =~ s/^'//;
      $this_noun =~ s/'$//;

      print "DEBUG_MT2: this_verb=($this_verb) this_noun=($this_noun)\n" if $debug_memtop == 1;

      $memprocess_entries{$this_verb} = $this_noun;
    }

    #---- WWW Details Line
    $cp_color = "white"; 
    my $table_row = "<tr bgcolor=$cp_color>
      <td>             $f_s   $memprocess_entries{'sn_process_name'} 
      <td>             $f_s   $memprocess_entries{'sn_process_spid'} 
      <td align=right> $f_s   $memprocess_entries{'sn_working_set_size_mb'}
    ";
    &snapshotsInsert($thishost, $sn_key, ++$sn_seq, $table_row); 
    print "HitMT3 sn_key=$sn_key\n" if $debug_memtop;
  } 
}

# -----------------------------------------------------------------------------
sub sqlUpSnapTopWaits
# -----------------------------------------------------------------------------
{
  my $debug_topwaits = 0; 

  my $sn_key = &snapshotsKeyGen("MSSQL_Top_Waits"); 
  &snapshotsInsert($thishost, $sn_key, 0, "MSSQL Top 5 Waits"); 
  print "HitTW1\n" if $debug_topwaits;

  my $table_heading = "<tr bgcolor=$table_headbgcolor>
    <th>$f_s MSSQL<br> Wait<br>Rank
    <th>$f_s MSSQL<br> Wait<br>Name 
    <th>$f_s MSSQL<br> Wait<br>Percent of Total 
    <th>$f_s Percent<br>Running<br>Total
  </tr>";

  &snapshotsInsert($thishost, $sn_key, 1, $table_heading); 
  print "HitTW2\n" if $debug_topwaits;
  my $sn_seq = 1; 
  my $zrunning = 0; 

  foreach $this_line (split('\n',$topwaits_data[$thishost]))
  {
    $this_waitname = (split(/\s/,$this_line)) [3];
    $this_waitrank = (split(/\s/,$this_line)) [4];
    $this_waitval  = (split(/\s/,$this_line)) [5];

    $zrunning += $this_waitval if $this_waitval > 0; 
    print "HitTW3 this_waitname=$this_waitname this_waitrank=$this_waitrank this_waitval=$this_waitval\n" if $debug_topwaits;

    #---- WWW Details Line
    $cp_color = "white"; 
    my $table_row = "<tr bgcolor=$cp_color>
      <td align=right> $f_s   $this_waitrank.
      <td>             $f_s   <a href='https://www.google.com/search?q=sql server wait $this_waitname'><b>$this_waitname</b></a>
      <td align=right> $f_s   <b>${this_waitval}% </b>
      <td align=right> $f_s   ${zrunning}% 
    ";
    &snapshotsInsert($thishost, $sn_key, ++$sn_seq, $table_row); 
    print "HitTW3 sn_key=$sn_key\n" if $debug_topwaits;
  } 
}

# -----------------------------------------------------------------------------
sub sqlUpSnapAO
# -----------------------------------------------------------------------------
{
  my $debug_snapao = 0; 

  my $sn_key = &snapshotsKeyGen("AO_Status"); 
  &snapshotsInsert($thishost, $sn_key, 0, "Current AlwaysOn (AO) Status"); 
  print "HitAO1\n" if $debug_snapao;

  my $table_heading = "<tr bgcolor=$table_headbgcolor>
    <th>$f_s AlwaysOn Status Indicator
    <th>$f_s Current Value PID 
  </tr>";
  &snapshotsInsert($thishost, $sn_key, 1, $table_heading); 

  print "HitAO2\n" if $debug_snapao;

  my $sn_seq = 1; 
  foreach $this_verb (sort keys %ao_statusinfo)
  {
    $this_noun = $ao_statusinfo{$this_verb}; 

    #---- WWW Details Line
    $cp_color = "white"; 
    my $table_row = "<tr bgcolor=$cp_color>
      <td>             $f_s   $this_verb
      <td>             $f_s   $this_noun
    ";
    &snapshotsInsert($thishost, $sn_key, ++$sn_seq, $table_row); 
    print "HitAO33 sn_key=$sn_key\n" if $debug_snapao;
  } 
}

# -----------------------------------------------------------------------------
sub sqlUpMissingIndexes
# -----------------------------------------------------------------------------
{
  my $debug_mi = 0; 

  $mitable = ""; 
  $middl   = ""; 

  foreach $this_line (split('\n',$sqlmissingindexes_data[$thishost]))
  {
    &packetParse($this_line) if $this_line =~ /^DDP:/;
    $pa_counter = -1;
    foreach $this_field (@pa_words)
    {
      $pa_counter++;
      print "DEBUG_MI: pa_words[$pa_counter]=($this_field)\n" if $debug_mi == 1;
      $this_verb = (split(/\=/,$this_field)) [0];
      $this_noun = (split(/\=/,$this_field)) [1];

      #---- Remove leading and trailing quotes from data field (after = sign)
      $this_noun =~ s/^'//;
      $this_noun =~ s/'$//;
      print "DEBUG_MI:   this_verb=$this_verb this_noun=$this_noun\n" if $debug_mi == 1;

      $this_verb = lc $this_verb; 
      $sql_midata{$this_verb} = $this_noun;
    }

    #---- Process *this* missing index (MI)
    print "DEBUG_MI: var1_improvementmeasure=$sql_midata{'var1_improvementmeasure'} var2_dbname=$sql_midata{'var2_dbname'}\n" if $debug_mi ;

    #---- DDP:<|>dbamon_mssql.pl<|>MISSINGINDEXES:<|>var1_ImprovementMeasure='31840.0'<|>var2_DBName='distribution'<|>var3_statement='[distribution].[dbo].[MSlogreader_history]'<|>var4_compiles='366238'<|>var5_userseeks='366238'<     |>var6_lastseek='2017-12-28 07:34:52.880'<|>var7_avguserimpact='80.260000000000005'<|>var8_CreateNCXStatement='CREATE INDEX [NCX_Missing_DBAmon_20171228_16798_16797_MSlogreader_history] ON [distribution].[dbo].[MSlogrea     der_history] ([runstatus]) INCLUDE ([agent_id], [timestamp])'<|>^M

    $z_avguserimpact = sprintf("%.2f", $sql_midata{'var7_avguserimpact'}); 

    #---- WWW Details Line
    $mitable .= "<tr bgcolor=$table_rowcolor>
      <td align=right>  $f_trow <b>  $sql_midata{'var1_improvementmeasure'} </b>
      <td >             $f_trow   $sql_midata{'var2_dbname'}
      <td >             $f_trow   $sql_midata{'var3_statement'}
      <td align=right>  $f_trow   $sql_midata{'var4_compiles'}
      <td align=right>  $f_trow   $sql_midata{'var5_userseeks'}
      <td >             $f_trow   $sql_midata{'var6_lastseek'}
      <td align=right>  $f_trow   $z_avguserimpact
      <td >             $f_trow   $sql_midata{'var8_createncxstatement'}
    ";

    #---- WWW DDL Line
    $middl .= "<tr bgcolor=$table_rowcolor>
      <td >             $f_trow   $sql_midata{'var8_createncxstatement'}
    ";
  } 

  #---- MissingIndexes Scoreboard
  &logDetails($thishost,"<br><a name='sqlUpMissingIndexes'> <h3>MSSQL High-Impact High-Usage Missing Indexes (If Any)</h3>");

  &logDetails($thishost, "$f_trow <b>Note:</b> For recommended Missing Indexes with multiple key columns, key columns are in random order. Specify these key columns in the correct order (with what you know about their cardinality). Also carefully compare all recommended Missing Indexes to see any similar indexes can be combined. "); 
  &logDetails($thishost, "<br>&nbsp;"); 

  if ($mitable ne "") 
  {
    &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
    &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
      <th>$f_trow Missing Index<br>Improvement Measure<br>(Threshold: $t_mi) 
      <th>$f_trow Database
      <th>$f_trow Table 
      <th>$f_trow SQL<br>Compiles
      <th>$f_trow User<br>Seeks 
      <th>$f_trow Last<br>Seek 
      <th>$f_trow Avg. User<br>Impact 
      <th>$f_trow Missing Index<br>DDL 
    </tr>");
    &logDetails($thishost,$mitable);
    &logDetails($thishost,"</table>");

    &logDetails($thishost, "<br>&nbsp;"); 
    &logDetails($thishost, "$f_trow All recommended Missing Indexes in a format that is easier to Copy/Paste:"); 
    &logDetails($thishost, "<br>&nbsp;"); 
    &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
    &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
      <th>$f_trow Missing Index DDL
    </tr>");
    &logDetails($thishost,$middl);
    &logDetails($thishost,"</table>");
  }
  else
  {
    &logDetails($thishost, "<br>&nbsp;"); 
    &logDetails($thishost, "<br>$f_trow <b>(No High-Impact High-Usage Missing Indexes found)</b>"); 
    &logDetails($thishost, "<br>&nbsp;"); 
  }

  &logDetails($thishost, "<br>&nbsp;"); 
  &logDetails($thishost, "$f_trow Query used to find Missing Indexes:"); 
  &logDetails($thishost, "<br>&nbsp;"); 
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_rowbgcolor>
    <td bgcolor=snow>$f_trow 
<pre>
SELECT  FLOOR(migs.avg_total_user_cost * ( migs.avg_user_impact / 100.0 )
              * ( migs.user_seeks + migs.user_scans )) AS [1_ImprovementMeasure] ,
        DB_NAME(mid.database_id) AS DB_Name ,
        mid.statement ,
        migs.unique_compiles ,
        migs.user_seeks ,
        -- migs.user_scans, (always zero)
        migs.last_user_seek ,
        migs.avg_user_impact ,
        'CREATE INDEX [NCX_Missing_DBAmon_' + CONVERT(CHAR(8), GETDATE(), 112)
        + '_' + CONVERT (VARCHAR, mig.index_group_handle) + '_'
        + CONVERT (VARCHAR, mid.index_handle) + '_'
        + LEFT(PARSENAME(mid.STATEMENT, 1), 32) + ']' + ' ON ' + mid.STATEMENT
        + ' (' + ISNULL(mid.equality_columns, '')
        + CASE WHEN mid.equality_columns IS NOT NULL
                    AND mid.inequality_columns IS NOT NULL THEN ','
               ELSE ''
          END + ISNULL(mid.inequality_columns, '') + ')' + ISNULL(' INCLUDE ('
                                                              + mid.included_columns
                                                              + ')', '') AS CreateNCXStatement 
FROM    sys.dm_db_missing_index_groups mig
        INNER JOIN sys.dm_db_missing_index_group_stats migs ON migs.group_handle = mig.index_group_handle
        INNER JOIN sys.dm_db_missing_index_details mid ON mig.index_handle = mid.index_handle
WHERE   migs.avg_total_user_cost * ( migs.avg_user_impact / 100.0 )
        * ( migs.user_seeks + migs.user_scans ) > $t_mi
ORDER BY 1 DESC;
</pre>");
  &logDetails($thishost,"</table>");

  &logDetails($thishost, "<hr>"); 
}

#-----------------------------------------------------------------------------
1;
