create table dbamon.instances
  (
    instance_key       varchar2(32)          ,
    dbamonmode         char(8)               not null,
    status             char(1)               not null,
    system             char(32)              not null,
    fqhostname         varchar2(128)          ,
    instance           char(32)              not null,
    model              char(16)              ,
    cpucount           int                   ,
    os                 char(24)              ,
    dbms               char(12)              not null,
    dbmsver            char(16)              ,
    dbmssn             char(16)              ,
    alloc              int                   ,
    used               int                   ,
    instance_mem_mb    int                   ,
    misc1              varchar2(80)          ,
    misc2              varchar2(80)          ,
    misc3              varchar2(80)          ,
    misc4              varchar2(80)          ,
    misc5              varchar2(80)          ,
    misc6              varchar2(80)          ,
    misc7              varchar2(80)          ,
    misc8              varchar2(80)          ,
    misc9              varchar2(80)          ,
    misc10             varchar2(80)          ,
    ts                 date                  default sysdate
  );
create index dbamon.instances_x1 on dbamon.instances (instance, dbamonmode);
